// Header for Evaluation Functions
// SlowChess 2003

struct PawnHashEntry
    {
	 unsigned int checksum;
	 unsigned char OpenFileW;
	 unsigned char OpenFileB;
	 unsigned char WeakFileB, WeakFileW;
	 short eval, flags;
	 short Mat, MatEnd;
    };

int Liquidate ( SBoard &Board );
short EvaluateBoard (const SBoard &Board, int alpha, int beta);
void Clear_PawnHash ( void );
unsigned int Pawn_HashBoard (SBoard &Board);

void EvalPawns ( const SBoard &Board, PawnHashEntry &TEntry);
void PawnRookEval ( SBoard &Board, int &PawnEval, int &RookEval );
int InitKingPawnProbe ( );

// If one side is up in material, it gets a bonus, using the number of total pieces on the board as the index into this array.
const int LIQUIDATION[36] = { 120, 120, 105, 90, 76, 64, 52, 40, 30, 20, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ,0, 0, 0, 0, 0};
#define MORE_PIECES 75

int inline MatEval ( const SBoard &Board, int nWP, int nBP, const int &MatVal)
{
	int eval = 0;

	if (Board.WPiece[14] != CAPTURED) nWP++; // Queen counts as 2 for this code
	if (Board.BPiece[14] != CAPTURED) nBP++;
	// More Pieces/ Number of pieces left
	if (MatVal >  198) eval+= LIQUIDATION [ nBP + nWP ];
	if (MatVal < -198) eval-= LIQUIDATION [ nBP + nWP ];
	if (nWP > nBP && nWP > 1) eval+= MORE_PIECES; // fixme > 1 is kinda crazy, maybe should be 1 minor
	if (nBP > nWP && nBP > 1) eval-= MORE_PIECES;

	return eval;
}

