// Slow Chess 
// by Jonathan Kreuzer
// copyright 2003

#include <windows.h>
#include <stdio.h>
#include "data.h"
#include "gui.h"
#include "transcript.h"
#include "search.h"
//#include <assert.h>


// Assembly Functions ----------------------------------

extern "C" int asmattackedbyBlack(unsigned char *);
extern "C" int asmattackedbyWhite(unsigned char *);

extern "C" int FindMovesWhiteKnightasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesWhiteKingasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesWhitePawnasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesWhiteQueenasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesWhiteRookasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesWhiteBishopasm(Movestruct *, unsigned char *, unsigned char *, int);

extern "C" int FindMovesBlackKnightasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesBlackKingasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesBlackPawnasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesBlackQueenasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesBlackRookasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindMovesBlackBishopasm(Movestruct *, unsigned char *, unsigned char *, int);

extern "C" int FindAMovesWhiteKnightasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesWhiteKingasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesWhitePawnasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesWhiteQueenasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesWhiteRookasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesWhiteBishopasm(Movestruct *, unsigned char *, unsigned char *, int);

extern "C" int FindAMovesBlackKnightasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesBlackKingasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesBlackPawnasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesBlackQueenasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesBlackRookasm(Movestruct *, unsigned char *, unsigned char *, int);
extern "C" int FindAMovesBlackBishopasm(Movestruct *, unsigned char *, unsigned char *, int);

char acDirec [128 * 128];

// -----------------
// Copy_Board2 just copies the extra data and not the pieces themselves
// -----------------
const int nSize = (sizeof ( SBoard ) - 120);

void inline Copy_Board2 (SBoard &DBoard, SBoard &CBoard)
{
memcpy ( &DBoard.Sq[120], &CBoard.Sq[120], nSize);
}
// -----------------------------
// Init Square Value Array
// -----------------------------
int SquareVals [ 128 * 16 ];
short BPawnValue[ 128 ];
short BPawnValueQS[ 128 ];
short BPawnValueEnd[ 128 ];
unsigned int KnightAttacks [ 256 ];

void InitSquareArray ( void )
{
int i, x, y;

i = WPAWN;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = ZeroValue [ x ];

i = WKNIGHT;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = WKnightValue [ x ];

i = WBISHOP;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = WBishopValue [ x ];

i = WROOK;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = WRookValue [ x ];

i = WQUEEN;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = WQueenValue [ x ];

i = WKING;
for (x = 0; x < 120; x++)
	SquareVals [ x + i*128] = WKingValue [ x ];


i = BPAWN;
for ( x = 0; x < 8; x++)
	for (y = 0; y < 8; y++)
	{
	BPawnValue [ SQ (x,y) ]    = -WPawnValue [ SQ(x,7-y) ];
	BPawnValueEnd [ SQ (x,y) ] = -WPawnValueEnd [ SQ(x,7-y) ];
	BPawnValueQS [ SQ (x,y) ] = -WPawnValueQS [ SQ(x,7-y) ];
	SquareVals [ SQ (x,y) + i*128] = -ZeroValue [ SQ (x, 7-y) ];
	}

i = BKNIGHT;
for ( x = 0; x < 8; x++)
	for ( y = 0; y < 8; y++)
	SquareVals [ SQ (x,y) + i*128] = -WKnightValue [ SQ (x, 7-y) ];

i = BBISHOP;
for ( x = 0; x < 8; x++)
	for ( y = 0; y < 8; y++)
	SquareVals [ SQ (x,y) + i*128] = -WBishopValue [ SQ (x, 7-y) ];

i = BROOK;
for ( x = 0; x < 8; x++)
	for ( y = 0; y < 8; y++)
	SquareVals [ SQ (x,y) + i*128] = -WRookValue [ SQ (x, 7-y) ];

i = BQUEEN;
for ( x = 0; x < 8; x++)
	for ( y = 0; y < 8; y++)
	SquareVals [ SQ (x,y) + i*128] = -WQueenValue [ SQ (x, 7-y) ];

i = BKING;
for ( x = 0; x < 8; x++)
	for ( y = 0; y < 8; y++)
	SquareVals [ SQ (x,y) + i*128] = -WKingValue [ SQ (x, 7-y) ];

int sq, sq2;

// Init Direction array
for (sq = 10; sq < 120; sq++)
	for (sq2 = 10; sq2 < 120; sq2++)
		{
		acDirec  [ sq + sq2*128 ] = 0;
		if (SQRANK[sq] == SQRANK[sq2])
			{
			if (sq2 > sq) acDirec [ sq + sq2*128 ] =  1;
			if (sq2 < sq) acDirec [ sq + sq2*128 ] = -1;
			}
		if (SQFILE[sq] == SQFILE[sq2])
			{
			if (sq2 > sq) acDirec [ sq + sq2*128 ] =  10;
			if (sq2 < sq) acDirec [ sq + sq2*128 ] = -10;
			}
		if (SQDIAG1[sq] == SQDIAG1[sq2])
			{
			if (sq2 > sq) acDirec [ sq + sq2*128 ] =  11;
			if (sq2 < sq) acDirec [ sq + sq2*128 ] = -11;
			}
		if (SQDIAG2[sq] == SQDIAG2[sq2])
			{
			if (sq2 > sq) acDirec [ sq + sq2*128 ] =  9;
			if (sq2 < sq) acDirec [ sq + sq2*128 ] = -9;
			}
		}

// Initalize Knight Attacks
ZeroMemory ( KnightAttacks, sizeof (int) * 256);
const int KN[8] = {8, 12, 19, 21, -8, -12, -19, -21 };
for (i = 0; i < 8; i++) KnightAttacks [ 128 + KN[i] ] = 1;
}

// -----------------------------
//
// Functions for Special Setup of the Board
//
// -----------------------------
void ClearBoard (SBoard &Board )
{
		Board.WCastle = 0; 
        Board.BCastle = 0; 
        Board.EnPassant = 120; 
        Board.SideToMove = WHITE; 
        Board.MatVal  = 0; 
        Board.GameTime = 1; 
		Board.LastReversible = 1; 
		Board.nWP = 0; 
		Board.nBP = 0;
		Board.nWPawns = 0;
		Board.nBPawns = 0;
		Board.nBMinors = 0;
		Board.nWMinors = 0;
/*		Board.nBQ = 0;
		Board.nWQ = 0;*/
		Board.TempValue = 0;

		for (int i = 0; i < 16; i++)
			{
			Board.WPiece [ i ] = CAPTURED;
			Board.BPiece [ i ] = CAPTURED;
			}

		int x,y;

        for (x = 0 ; x < 122; x++)  // Invalid Squares
             Board.Sq[x] = INVALID;

        for (y = 0; y < 8; y++) // Empty Squares
			for (x = 0; x < 8; x++)
				Board.Sq [ SQ (x,y) ] = EMPTY;
}

// -----------------------------
//
// -----------------------------
int AddPawn ( unsigned char *pPiece, int nSq )
{
	int n = 0;
	while ( pPiece [n] != CAPTURED && n<8) n++;
	if (n == 8) return FALSE;
	pPiece [ n ] = nSq;
	return TRUE;
}

void AddPiece (SBoard &Board, int x, int y, char piece)
	{
	int n;

	if (Board.Sq[ SQ (x,y ) ] != EMPTY) return;

			// WHITE PIECE
			if (piece == WPAWN)
				{
				if (AddPawn ( Board.WPiece, SQ (x,y) ) == FALSE) return;
				Board.nWPawns++;
				}
			if (piece == WKNIGHT)
				{
				n = 8;
				if (Board.WPiece [ n ] != CAPTURED) n++;
				if (Board.WPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.WPiece [ n ] = SQ (x,y);
				Board.nWP++;
				Board.nWMinors++;
				}
			if (piece == WBISHOP)
				{
				n = 10;
				if (Board.WPiece [ n ] != CAPTURED) n++;
				if (Board.WPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.WPiece [ n ] = SQ (x,y);
				Board.nWP++;
				Board.nWMinors++;
				}
			if (piece == WROOK)
				{
				n = 12;
				if (Board.WPiece [ n ] != CAPTURED) n++;
				if (Board.WPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.WPiece [ n ] = SQ (x,y);
				Board.nWP++;
				}
			if (piece == WQUEEN)
				{
				if (Board.WPiece [ 14 ] != CAPTURED)
					{if (AddPawn ( Board.WPiece, SQ (x,y) ) == FALSE) return;
					 Board.nWP++;
					 //Board.nWQ++;
					}
				else
					{
					Board.WPiece [ 14 ] = SQ (x,y);
					Board.nWP++;
					//Board.nWQ++;
					}
				}
			if (piece == WKING)
				{
				if (Board.WPiece [ 15 ] != CAPTURED) return;
				Board.WPiece [ 15 ] = SQ (x,y);
				}

			// BLACK PIECE
			if (piece == BPAWN)
				{
				if (AddPawn ( Board.BPiece, SQ (x,y) ) == FALSE) return;
				Board.nBPawns++;
				}
			if (piece == BKNIGHT)
				{
				n = 8;
				if (Board.BPiece [ n ] != CAPTURED) n++;
				if (Board.BPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.BPiece [ n ] = SQ (x,y);
				Board.nBP++;
				Board.nBMinors++;
				}
			if (piece == BBISHOP)
				{
				n = 10;
				if (Board.BPiece [ n ] != CAPTURED) n++;
				if (Board.BPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.BPiece [ n ] = SQ (x,y);
				Board.nBP++;
				Board.nBMinors++;
				}
			if (piece == BROOK)
				{
				n = 12;
				if (Board.BPiece [ n ] != CAPTURED) n++;
				if (Board.BPiece [ n ] != CAPTURED) return; // FIXME promopawns
				Board.BPiece [ n ] = SQ (x,y);
				Board.nBP++;
				}
			if (piece == BQUEEN)
				{
				if (Board.BPiece [ 14 ] != CAPTURED)
					{if (AddPawn ( Board.BPiece, SQ (x,y) ) == FALSE) return;
					 Board.nBP++;
					 //Board.nBQ++;
					}
				else
					{
					Board.BPiece [ 14 ] = SQ (x,y);
					Board.nBP++;
					//Board.nBQ++;
					}
				}
			if (piece == BKING)
				{
				if (Board.BPiece [ 15 ] != CAPTURED) return;
				Board.BPiece [ 15 ] = SQ (x,y);
				}

 		Board.Sq [ SQ ( x, y ) ] = piece;

		Board.TempValue = 0;
        Board.MatVal  = 0; // incrementally updated Material Balance
		for (x = 0; x < 8; x++)
			for (y = 0; y < 8; y++)
				{
				if ( Board.Sq [ SQ (x,y) ] != EMPTY && (Board.Sq [ SQ (x,y) ]&7) != WKING) Board.TempValue += SquareVals [ Board.Sq [ SQ (x,y) ] * 128 + SQ (x,y) ];
				if ( Board.Sq [ SQ (x,y) ] != EMPTY && (Board.Sq [ SQ (x,y) ]&7) != WKING) Board.MatVal += PieceValues [ Board.Sq [ SQ (x,y) ]];
				}			
			Board.PawnHash = Pawn_HashBoard (Board);
	       }

// -----------------
// Setup_Board
// Setup the starting position and flags on Board[]
// -----------------
void Setup_Board (SBoard &Board, int reset)
        {
        int x, y;
        int Bnum = 0, Wnum = 0;
        
		memset ( &Board, 0, sizeof (SBoard ) );

        for (x = 0 ; x < 122; x++)  // Invalid Squares
             Board.Sq[x] = INVALID;

        for (y = 0; y < 8; y++) // Empty Squares
			for (x = 0; x < 8; x++)
				Board.Sq [ SQ (x,y) ] = EMPTY;
        
        for (x = 0; x< 8; x++) // Pawns
           {
			Board.Sq [ SQ (x,1) ] = BPAWN;
            Board.BPiece [ Bnum++ ] = SQ (x,1); 
            Board.Sq [ SQ (x,6) ] = WPAWN;
            Board.WPiece [ Wnum++ ] = SQ (x,6);
           }

		// Pieces
        Board.WPiece [ 8 ] = SQ (1,7);
        Board.BPiece [ 8 ] = SQ (1,0); 
        Board.WPiece [ 9 ] = SQ (6,7);
        Board.BPiece [ 9 ] = SQ (6,0);  
        Board.WPiece [ 10 ] = SQ (2,7);  
        Board.BPiece [ 10 ] = SQ (2,0);  
        Board.WPiece [ 11 ] = SQ (5,7); 
        Board.BPiece [ 11 ] = SQ (5,0);  
        Board.WPiece [ 12 ] = SQ (0,7);  
        Board.BPiece [ 12 ] = SQ (0,0);  
        Board.WPiece [ 13 ] = SQ (7,7);  
        Board.BPiece [ 13 ] = SQ (7,0);  
        Board.WPiece [ 14 ] = SQ (3,7);  
        Board.BPiece [ 14 ] = SQ (3,0);  
        Board.WPiece [ 15 ] = SQ (4,7); 
        Board.BPiece [ 15 ] = SQ (4,0);  
                
        Board.Sq [ SQ (1,0) ] = BKNIGHT; Board.Sq [ SQ (1,7) ] = WKNIGHT; 
		Board.Sq [ SQ (6,0) ] = BKNIGHT; Board.Sq [ SQ (6,7) ] = WKNIGHT;
        Board.Sq [ SQ (2,0) ] = BBISHOP; Board.Sq [ SQ (2,7) ] = WBISHOP;
		Board.Sq [ SQ (5,0) ] = BBISHOP; Board.Sq [ SQ (5,7) ] = WBISHOP;
        Board.Sq [ SQ (0,0) ] = BROOK;   Board.Sq [ SQ (0,7) ] = WROOK;
		Board.Sq [ SQ (7,0) ] = BROOK;   Board.Sq [ SQ (7,7) ] = WROOK;
        Board.Sq [ SQ (3,0) ] = BQUEEN;  Board.Sq [ SQ (3,7) ] = WQUEEN; 
		Board.Sq [ SQ (4,0) ] = BKING;	 Board.Sq [ SQ (4,7) ] = WKING;

        Board.WCastle = 0; // Can Castle WHITE
        Board.BCastle = 0; // Can Castle BLACK
        Board.EnPassant = 120; // no enpassant
        Board.SideToMove = WHITE; // Side to Move
        Board.MatVal  = 0; // incrementally updated piece value
        Board.GameTime = 1; // Gametime (Ply Count of game)
		Board.LastReversible = 1; // last unreversible move (Capture/Pawn move)
		Board.nWP = 7; // number of white pieces except the pawns (or king)
		Board.nBP = 7;
		Board.nWPawns = 8;
		Board.nBPawns = 8;
		Board.nBMinors = 4;
		Board.nWMinors = 4;
		//Board.nWQ = 1;
		//Board.nBQ = 1;
		Board.TempValue = 0;
		for (x = 0; x < 8; x++)
			for (y = 0; y < 8; y++)
				{
				if ( Board.Sq [ SQ (x,y) ] != EMPTY ) Board.TempValue += SquareVals [ Board.Sq [ SQ (x,y) ] * 128 + SQ (x,y) ];
				}
       
		if (reset == 1) 
			{
			HWND hwndList = GetDlgItem(sideHWND, 109);  
			SendMessage(hwndList, LB_RESETCONTENT, 0, 0);
			}
        }
        
// ----------------
// Clear the Movelist
// ----------------
void inline Clear_Movelist(Movestruct &Movelist)
        {
		 Movelist.nummoves = 0;
         Movelist.numAttackmoves = 0;
         Movelist.eval = 0;
		 Movelist.extended = 0;
        }

// -----------------
// Add a Move to Movelist
// -----------------
void inline AddMove ( Movestruct &Movelist, const int src, const int dst, const int type, const int piece)
        {
		int i;
         // Sort Attacks First
        if (piece == EMPTY)
                {Movelist.nummoves ++;
                 i = (Movelist.nummoves + 50);
                }
               
        else   {Movelist.numAttackmoves ++;
                 i = Movelist.numAttackmoves;
                }
       
        Movelist.Moves[i] = src + (dst<<8) + (type<<16);
        }
        
// ----------------
// Returns 1 if a the piece on square is attacked by the opposite color
// ----------------
int IsAttacked (SBoard &Board, unsigned char square, unsigned char color)
    {
    if (color == WHITE) return asmattackedbyBlack (&Board.Sq[square]);
                   else return asmattackedbyWhite (&Board.Sq[square]);
    }

// ----------------
// Returns 1 if color is currently in Check
// ----------------
int IsCheck(unsigned char color, SBoard &Board)
     {
     if (color == WHITE) return asmattackedbyBlack (&Board.Sq[ Board.WPiece[ 15 ] ] );
                    else return asmattackedbyWhite (&Board.Sq[ Board.BPiece[ 15 ] ] );
     }


// -----------------
//  Find Moves for a promoted pawn
// -----------------
void FindMovesWhitePromotedPawn ( Movestruct *WMoves, SBoard &Board, unsigned char *Boardptr, int data)
        {
         if     (*Boardptr == WQUEEN)   FindMovesWhiteQueenasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WROOK)   FindMovesWhiteRookasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WBISHOP) FindMovesWhiteBishopasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WKNIGHT) FindMovesWhiteKnightasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WPAWN)   FindMovesWhitePawnasm(WMoves, Board.Sq, Boardptr, data);
         }

void FindMovesBlackPromotedPawn ( Movestruct *WMoves, SBoard &Board, unsigned char *Boardptr, int data)
        {
         if      (*Boardptr == BQUEEN)  FindMovesBlackQueenasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BROOK)   FindMovesBlackRookasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BBISHOP) FindMovesBlackBishopasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BKNIGHT) FindMovesBlackKnightasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BPAWN)   FindMovesBlackPawnasm(WMoves, Board.Sq, Boardptr, data);
         }    

void FindAMovesWhitePromotedPawn ( Movestruct *WMoves, SBoard &Board, unsigned char *Boardptr, int data)
        {
         if      (*Boardptr == WQUEEN)  FindAMovesWhiteQueenasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WROOK)   FindAMovesWhiteRookasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WBISHOP) FindAMovesWhiteBishopasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WKNIGHT) FindAMovesWhiteKnightasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == WPAWN)   FindAMovesWhitePawnasm(WMoves, Board.Sq, Boardptr, data);
         }

void FindAMovesBlackPromotedPawn ( Movestruct *WMoves, SBoard &Board, unsigned char *Boardptr, int data)
        {
         if      (*Boardptr == BQUEEN)  FindAMovesBlackQueenasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BROOK)   FindAMovesBlackRookasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BBISHOP) FindAMovesBlackBishopasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BKNIGHT) FindAMovesBlackKnightasm(WMoves, Board.Sq, Boardptr, data);
         else if (*Boardptr == BPAWN)   FindAMovesBlackPawnasm(WMoves, Board.Sq, Boardptr, data);
         }         

// -----------------------------------
// Find all the moves on a Board for WHITE and store in WMoves
// -----------------------------------
void FindMovesWhite(SBoard &Board, Movestruct &WMoves/*, int check*/)
        {
         Clear_Movelist(WMoves); 

		 // Castling!
         if (WMoves.ischeck == 0) 
            {
		     if (Board.WCastle == 1 || Board.WCastle == 0)
                if (Board.Sq [96] == WKING && Board.Sq [97] == EMPTY && Board.Sq [98] == EMPTY && Board.Sq [99] == WROOK)
			 	  if (IsAttacked (Board, 97, WHITE) == 0)
						AddMove (WMoves, 124, 98, 15, EMPTY);
                   
             if (Board.WCastle == 2 || Board.WCastle == 0)
                if (Board.Sq [96] == WKING && Board.Sq [95] == EMPTY && Board.Sq [94] == EMPTY && Board.Sq [93] == EMPTY && Board.Sq [92] == WROOK)
				  if (IsAttacked (Board, 95, WHITE) == 0)
					AddMove (WMoves, 125, 94, 15, EMPTY);
            }
		  if (WMoves.ischeck != 0) 
			{FindMovesWhiteKingasm(&WMoves, Board.Sq, &Board.Sq[ Board.WPiece[15] ], Board.WPiece[ 15 ] + 15 * 65536);
			 if (WMoves.ischeck == 2) return; // Checked by 2 pieces at once
			}
		  // Pawn Moves
		  for (int i = 0; i < 8; i++)
			{
			int nLoc = Board.WPiece[ i ];
			if (nLoc !=CAPTURED)
				{
                if (Board.Sq[ nLoc ] == WPAWN) 	FindMovesWhitePawnasm(&WMoves, Board.Sq, &Board.Sq [ nLoc], nLoc + (i << 16) );
					else FindMovesWhitePromotedPawn(&WMoves, Board, &Board.Sq [ nLoc ], nLoc + (i << 16) );
				}
			}
  
           if (Board.WPiece[ 8 ]!=CAPTURED) FindMovesWhiteKnightasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[8 ]], Board.WPiece[8 ] + 8 * 65536);
           if (Board.WPiece[ 9 ]!=CAPTURED) FindMovesWhiteKnightasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[9 ]], Board.WPiece[9 ] + 9 * 65536);
           if (Board.WPiece[10 ]!=CAPTURED) FindMovesWhiteBishopasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[10 ]], Board.WPiece[10] + 10 * 65536);
           if (Board.WPiece[11 ]!=CAPTURED) FindMovesWhiteBishopasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[11 ]], Board.WPiece[11] + 11 * 65536);
           if (Board.WPiece[12 ]!=CAPTURED) FindMovesWhiteRookasm  (&WMoves, Board.Sq, &Board.Sq[Board.WPiece[12 ]], Board.WPiece[12] + 12 * 65536);
           if (Board.WPiece[13 ]!=CAPTURED) FindMovesWhiteRookasm  (&WMoves, Board.Sq, &Board.Sq[Board.WPiece[13 ]], Board.WPiece[13] + 13 * 65536);
           if (Board.WPiece[14 ]!=CAPTURED) FindMovesWhiteQueenasm(&WMoves, Board.Sq, &Board.Sq[ Board.WPiece[14 ]], Board.WPiece[14 ] + 14 * 65536);
           if (WMoves.ischeck == 0) FindMovesWhiteKingasm(&WMoves, Board.Sq, &Board.Sq[ Board.WPiece[15] ], Board.WPiece[ 15 ] + 15 * 65536);
   		   return;
       }

// Check Test First
void FindMovesWhiteCh(SBoard &Board, Movestruct &Moves)
{
	Moves.ischeck = IsCheck (WHITE, Board);
	FindMovesWhite ( Board, Moves );
}
// -------------------------------------------------
// Find all the moves on a Board for BLACK and store in BMoves
// -------------------------------------------------
void FindMovesBlack(SBoard &Board, Movestruct &BMoves )
        {
         Clear_Movelist(BMoves);

		 // Castling!
         if (BMoves.ischeck == 0) 
            {
		     if (Board.BCastle == 1 || Board.BCastle == 0)
                 if (Board.Sq [26] == BKING && Board.Sq[27] == EMPTY && Board.Sq[28] == EMPTY && Board.Sq[29] == BROOK)
                       if (IsAttacked (Board, 27, BLACK) == 0)
                              AddMove (BMoves, 126, 28, 15, EMPTY);
                   
             if (Board.BCastle == 2 || Board.BCastle == 0)
                 if (Board.Sq[26] == BKING && Board.Sq[25] == EMPTY && Board.Sq[24] == EMPTY && Board.Sq[23] == EMPTY && Board.Sq[22] == BROOK)
                       if (IsAttacked (Board, 25, BLACK) == 0)
							 AddMove (BMoves, 127, 24, 15, EMPTY);
            }
		 if (BMoves.ischeck != 0) 
			{FindMovesBlackKingasm(&BMoves, Board.Sq, &Board.Sq[ Board.BPiece[15] ], Board.BPiece[ 15 ] + 15 * 65536);
			if (BMoves.ischeck == 2) return;          
			}

		  // Pawn Moves
		  for (int i = 0; i < 8; i++)
			{
			int nLoc = Board.BPiece[ i ];
			if (nLoc !=CAPTURED)
				{
                if (Board.Sq[ nLoc ] == BPAWN) 	FindMovesBlackPawnasm(&BMoves, Board.Sq, &Board.Sq [ nLoc], nLoc + (i<<16) );
					else FindMovesBlackPromotedPawn(&BMoves, Board, &Board.Sq [ nLoc ], nLoc + (i<<16) );
				}
			}
  
           if (Board.BPiece[ 8 ]!=CAPTURED) FindMovesBlackKnightasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[8 ]], Board.BPiece[8 ] + 8 * 65536);
           if (Board.BPiece[ 9 ]!=CAPTURED) FindMovesBlackKnightasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[9 ]], Board.BPiece[9 ] + 9 * 65536);
           if (Board.BPiece[10 ]!=CAPTURED) FindMovesBlackBishopasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[10 ]], Board.BPiece[10] + 10 * 65536);
           if (Board.BPiece[11 ]!=CAPTURED) FindMovesBlackBishopasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[11 ]], Board.BPiece[11] + 11 * 65536);
           if (Board.BPiece[12 ]!=CAPTURED) FindMovesBlackRookasm  (&BMoves, Board.Sq, &Board.Sq[Board.BPiece[12 ]], Board.BPiece[12] + 12 * 65536);
           if (Board.BPiece[13 ]!=CAPTURED) FindMovesBlackRookasm  (&BMoves, Board.Sq, &Board.Sq[Board.BPiece[13 ]], Board.BPiece[13] + 13 * 65536);
           if (Board.BPiece[14 ]!=CAPTURED) FindMovesBlackQueenasm(&BMoves, Board.Sq, &Board.Sq[ Board.BPiece[14 ]], Board.BPiece[14 ] + 14 * 65536);
           if (BMoves.ischeck == 0) FindMovesBlackKingasm(&BMoves, Board.Sq, &Board.Sq[ Board.BPiece[15] ], Board.BPiece[ 15 ] + 15 * 65536);
   		   return;
       }

// Check Test First
void FindMovesBlackCh(SBoard &Board, Movestruct &Moves)
{
	Moves.ischeck = IsCheck (BLACK, Board);
	FindMovesBlack ( Board, Moves );
}
// -----------------------------------
// Find all ATTACKING moves on a Board for WHITE
// -----------------------------------
void FindAttackMovesWhite(SBoard &Board, Movestruct &WMoves)
        {
          Clear_Movelist(WMoves);
            
          for (int i = 0; i < 8; i++)
			{
			int nLoc = Board.WPiece[ i ];
			if (nLoc !=CAPTURED)
				{
                if (Board.Sq[ nLoc ] == WPAWN) 	// Find Attacks & Promotions
					{
					FindAMovesWhitePawnasm(&WMoves, Board.Sq, &Board.Sq [ nLoc], nLoc + i * 65536);
					if ( SQRANK [ nLoc ] == 7 && Board.Sq[ nLoc - 10] == EMPTY) AddMove (WMoves, nLoc, nLoc-10, i, BPAWN);
					}
					else FindAMovesWhitePromotedPawn(&WMoves, Board, &Board.Sq [ nLoc ], nLoc + i * 65536);
				}
			}
  
           if (Board.WPiece[ 8 ]!=CAPTURED) FindAMovesWhiteKnightasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[8 ]], Board.WPiece[8 ] + 8 * 65536);
           if (Board.WPiece[ 9 ]!=CAPTURED) FindAMovesWhiteKnightasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[9 ]], Board.WPiece[9 ] + 9 * 65536);
           if (Board.WPiece[10 ]!=CAPTURED) FindAMovesWhiteBishopasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[10 ]], Board.WPiece[10] + 10 * 65536);
           if (Board.WPiece[11 ]!=CAPTURED) FindAMovesWhiteBishopasm(&WMoves, Board.Sq, &Board.Sq[Board.WPiece[11 ]], Board.WPiece[11] + 11 * 65536);
           if (Board.WPiece[12 ]!=CAPTURED) FindAMovesWhiteRookasm  (&WMoves, Board.Sq, &Board.Sq[Board.WPiece[12 ]], Board.WPiece[12] + 12 * 65536);
           if (Board.WPiece[13 ]!=CAPTURED) FindAMovesWhiteRookasm  (&WMoves, Board.Sq, &Board.Sq[Board.WPiece[13 ]], Board.WPiece[13] + 13 * 65536);
           if (Board.WPiece[14 ]!=CAPTURED) FindAMovesWhiteQueenasm (&WMoves, Board.Sq, &Board.Sq[Board.WPiece[14 ]], Board.WPiece[14 ] + 14 * 65536);
           FindAMovesWhiteKingasm(&WMoves, Board.Sq, &Board.Sq[ Board.WPiece[15] ], Board.WPiece[ 15 ] + 15 * 65536);
       }

// -----------------------------------
// Find all ATTACKING moves on a Board for BLACK
// -----------------------------------
void FindAttackMovesBlack(SBoard &Board, Movestruct &BMoves)
        {
         Clear_Movelist(BMoves);
	       
		  for (int i = 0; i < 8; i++)
			{
			int nLoc = Board.BPiece[ i ];
			if (nLoc !=CAPTURED)
				{
                if (Board.Sq[ nLoc ] == BPAWN) 	
					{
					 FindAMovesBlackPawnasm(&BMoves, Board.Sq, &Board.Sq [ nLoc], nLoc + i * 65536);
					 if ( SQRANK [ nLoc ] == 2 && Board.Sq[ nLoc+10] == EMPTY) AddMove (BMoves, nLoc, nLoc+10, i, WPAWN);
					}
					else FindAMovesBlackPromotedPawn(&BMoves, Board, &Board.Sq [ nLoc ], nLoc + i * 65536);
				}
			}
  
           if (Board.BPiece[ 8 ]!=CAPTURED) FindAMovesBlackKnightasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[8 ]], Board.BPiece[8 ] + 8 * 65536);
           if (Board.BPiece[ 9 ]!=CAPTURED) FindAMovesBlackKnightasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[9 ]], Board.BPiece[9 ] + 9 * 65536);
           if (Board.BPiece[10 ]!=CAPTURED) FindAMovesBlackBishopasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[10 ]], Board.BPiece[10] + 10 * 65536);
           if (Board.BPiece[11 ]!=CAPTURED) FindAMovesBlackBishopasm(&BMoves, Board.Sq, &Board.Sq[Board.BPiece[11 ]], Board.BPiece[11] + 11 * 65536);
           if (Board.BPiece[12 ]!=CAPTURED) FindAMovesBlackRookasm  (&BMoves, Board.Sq, &Board.Sq[Board.BPiece[12 ]], Board.BPiece[12] + 12 * 65536);
           if (Board.BPiece[13 ]!=CAPTURED) FindAMovesBlackRookasm  (&BMoves, Board.Sq, &Board.Sq[Board.BPiece[13 ]], Board.BPiece[13] + 13 * 65536);
           if (Board.BPiece[14 ]!=CAPTURED) FindAMovesBlackQueenasm (&BMoves, Board.Sq, &Board.Sq[ Board.BPiece[14 ]], Board.BPiece[14 ] + 14 * 65536);
           FindAMovesBlackKingasm(&BMoves, Board.Sq, &Board.Sq[ Board.BPiece[15] ], Board.BPiece[ 15 ] + 15 * 65536);
       }       

// ----------------------
//   Move the Pieces on array specified by Board
//   Returns a nonzero value if a capture is made 
//   Also includes special code for Castling, En Passant, and promotion.
// ----------------------
int Do_Move (SBoard &Board, const int Move, int &u1, int &u2, const int nUpgrade)
        {
        int retVal = 31001;

        int src = MSrc (Move); // Source Square
        int dst = MDst (Move); // Destination Square
        int nPiece = MPiece(Move); // Piece Number
		int nPType = Board.Sq [ src ];	// Piece Type

        u1 = dst + (src << 8);
		u2 = Board.Sq[dst] + ( nPType <<8 ); // for Undo
                  
        if (Board.SideToMove == WHITE) Board.SideToMove = BLACK; else Board.SideToMove = WHITE;
		Board.GameTime++; 

        // Castling
        if (src > 123)
			{
			Board.EnPassant = 120; 

            if (src == 124) // White Castle 
                    {u1= (96) + ((98)<<8) + ((99)<<16) + ((97)<<24);
                     u2 = Board.Sq[96] + (Board.Sq[98]<<8) + (Board.Sq[99]<<16) + (Board.Sq[97]<<24);
                     Board.Sq[96] = EMPTY;  Board.Sq[97] = WROOK; Board.Sq[98] = WKING; Board.Sq[99] = EMPTY;
                     Board.WPiece [ 15 ] = 98; Board.WPiece[ 13 ] = 97;
					 Board.WCastle = 4;
					 Board.TempValue += SquareVals [ WROOK * 128 + 97] - SquareVals [ WROOK * 128 + 99];
                     return 0;
                    }
             else if (src == 125)
                    {u1= (96) + ((94)<<8) + ((92)<<16) + ((95)<<24);
                     u2 = Board.Sq[96] + (Board.Sq[94]<<8) + (Board.Sq[92]<<16) + (Board.Sq[95]<<24);
                     Board.Sq[96] = EMPTY;  Board.Sq[95] = WROOK; Board.Sq[94] = WKING;  Board.Sq[92] = EMPTY;
	                 Board.WPiece [ 15 ] = 94; Board.WPiece[ 12 ] = 95;
					 Board.WCastle = 4;
 					 Board.TempValue += SquareVals [ WROOK * 128 + 95] - SquareVals [ WROOK * 128 + 92];
                     return 0;
                    }
             else if (src == 126) // Black Castle
                    {u1= (26) + ((28)<<8) + ((29)<<16) + ((27)<<24);
                     u2 = Board.Sq[26] + (Board.Sq[28]<<8) + (Board.Sq[29]<<16) + (Board.Sq[27]<<24);
                     Board.Sq[26] = EMPTY;  Board.Sq[27] = BROOK; Board.Sq[28] = BKING; Board.Sq[29] = EMPTY;
                     Board.BPiece[15] = 28; Board.BPiece[13] = 27; 
					 Board.BCastle = 4;
 					 Board.TempValue += SquareVals [ BROOK * 128 + 27] - SquareVals [ BROOK * 128 + 29];
                     return 0;
                    }
             else if (src == 127)
                    {u1 = (26) + ((24)<<8) + ((22)<<16) + ((25)<<24);
                     u2 = Board.Sq[26] + (Board.Sq[24]<<8) + (Board.Sq[22]<<16) + (Board.Sq[25]<<24);
                     Board.Sq[26] = EMPTY;  Board.Sq[25] = BROOK; Board.Sq[24] = BKING; Board.Sq[22] = EMPTY;
                     Board.BPiece[15] = 24; Board.BPiece[12] = 25; 
					 Board.BCastle = 4;
  					 Board.TempValue += SquareVals [ BROOK * 128 + 25] - SquareVals [ BROOK * 128 + 22];
                     return 0;
                    }
			}

		// If the King is Captured, The SlowChess search may go crazy and crash
		/*if ( (Board.Sq[dst]&7) == (WKING) )
			{
			int u = 5;
			u=1;
			}*/
		//assert ( (Board.Sq[dst]&7) != (WKING) );

		// Check/Update Castling Option flags
        if (Board.WCastle <3)
                {
				 if (src == 96) Board.WCastle = 3; // King Moved
                 if (src == 99 || dst == 99)  Board.WCastle |=2; // Rook Moved or was captured
                 if (src == 92 || dst == 92)  Board.WCastle |=1; // Rook Moved or was captured
                }
        if (Board.BCastle <3)
                {
				 if (src == 26) Board.BCastle = 3; 
                 if (src == 29 || dst == 29) Board.BCastle |=2;
                 if (src == 22 || dst == 22) Board.BCastle |=1;
                }
        
        // Piece Captures
		unsigned char *pPieces;

        if (Board.Sq[dst] != EMPTY)
                {
                 Board.LastReversible = Board.GameTime +1; // unreversible

                 if (Board.Sq[dst] < 8) // White piece Taken
                       {
						pPieces = Board.WPiece;
						if (Board.Sq[dst] == WPAWN) 
							{
							 Board.PawnHash -= WPHashSq [ dst ];
							 Board.nWPawns--;
							}
							else 
							{
							 if (abs(PieceValues[ Board.Sq[dst] ] + PieceValues[ nPType ]) < 70) retVal = dst; // for recapture ext
							 Board.nWP--;
							 if (PieceValues[ Board.Sq[dst] ] < 400) Board.nWMinors--;
							}
						Board.MatVal -= PieceValues[ Board.Sq[dst] ]; 
                       }
                else	// Black piece Taken
                       {
						pPieces = Board.BPiece;
						if (Board.Sq[dst] == BPAWN) 
							{
							 Board.PawnHash -= BPHashSq [ dst ];
							 Board.nBPawns--;
							}	
							else 
							{
							 if (abs(PieceValues[ Board.Sq[dst] ] + PieceValues[ nPType ]) < 70) retVal = dst; // for recapture ext
							 Board.nBP--;
							 if (PieceValues[ Board.Sq[dst] ] > -400) Board.nBMinors--;
							}
						Board.MatVal -= PieceValues[ Board.Sq[dst] ]; 
                       }
				
				Board.TempValue -= SquareVals [ Board.Sq [ dst ] * 128 + dst];

                 // Mark piece as captured in location list
                 for (int x = 0; x < 16; x++)
                     if ( dst == pPieces[x])
                        {
						pPieces[x] = CAPTURED;
						break;
						}
                }
        
        // EnPassant Capture
        else if (dst == Board.EnPassant && (nPType & 7) == WPAWN) 
                {
				 retVal = ENPASSANT;
				 if (nPType == WPAWN) // White Captures Black
                    {
					u1+= ((dst+10)<<16); u2 += Board.Sq[dst+10]<<16;
					Board.Sq[dst+10] = EMPTY;
					Board.PawnHash -= BPHashSq [ dst + 10 ];
					Board.nBPawns--;
                    Board.MatVal += PieceValues[ WPAWN ];
					Board.TempValue -= SquareVals [ BPAWN * 128 + dst + 10 ];
                    for (int x = 0; x < 8; x++)
						if ( dst+ 10  == Board.BPiece[x])
							{ Board.BPiece[ x ] = CAPTURED; 
								break;}
                    }
					else 	// Black Captures White
					{
					u1+= ((dst-10)<<16); u2 += Board.Sq[dst-10]<<16;
                    Board.Sq[dst-10] = EMPTY;
					Board.PawnHash -= WPHashSq [ dst - 10 ];
					Board.nWPawns--;
                    Board.MatVal -= PieceValues[ WPAWN ];
					Board.TempValue -= SquareVals [ WPAWN * 128 + dst - 10 ];
                    for ( int x = 0; x < 8; x++)
                           if ( dst - 10 == Board.WPiece[ x ])
                              { Board.WPiece[ x ] = CAPTURED;  
								break; 
						   }
                    }
				}

		// incremental update of pieces on Square Value (for non-kings)
		if ( (nPType&7) != WKING ) Board.TempValue += SquareVals [ nPType * 128 + dst] - SquareVals [ nPType * 128 + src];

		// Pawn Moves
        Board.EnPassant = 120; // no Enpassant
        if (nPType == WPAWN) 
			{
			Board.PawnHash += WPHashSq [ dst ] - WPHashSq [ src ];
			Board.LastReversible = Board.GameTime+1; // unreversible
			// Set EnPassant Sq if pawn moves forwards 2 & opponent has a pawn to capture it
			if (src-dst > 12 && (Board.Sq [dst-1] == BPAWN || Board.Sq [dst+1] == BPAWN))
				{Board.EnPassant = src - 10; } 

			if (SQRANK[dst]==7) retVal = PAWNPUSH;
			else if (retVal!=ENPASSANT && SQRANK[dst]==6 && Board.nBP <=1 && Board.Sq[dst-10] == EMPTY  && Board.Sq[dst-9] != BPAWN  && Board.Sq[dst-11] != BPAWN) 
					 retVal = PAWNPUSH2;
			if (SQRANK[dst]==8) // PAWN promo
					{
				     Board.MatVal += PieceValues[ nUpgrade ] - PieceValues[ WPAWN ];
					 if (nUpgrade < 5  ) Board.nWMinors++;
					 Board.nWP++;
					 Board.nWPawns--;
					 nPType += (nUpgrade - WPAWN); 
					} 
			}
        else if (nPType == BPAWN) 
			{
			Board.PawnHash += BPHashSq [ dst ] - BPHashSq [ src ];
			Board.LastReversible = Board.GameTime+1; // unreversible
			// Set EnPassant Sq if pawn moves forwards 2 & opponent has a pawn to capture it
			if (dst-src > 12 && (Board.Sq [dst-1] == WPAWN || Board.Sq [dst+1] == WPAWN))
				{Board.EnPassant = src + 10;}

			if (SQRANK[dst]==2) retVal = PAWNPUSH;
				else if (retVal!=ENPASSANT && SQRANK[dst]==3 && Board.nWP <=1 && Board.Sq[dst+10] == EMPTY && Board.Sq[dst+9] != WPAWN  && Board.Sq[dst+11] != WPAWN )
					  retVal = PAWNPUSH2;
			if (SQRANK[dst]==1) // PAWN promo
					{
					 Board.MatVal -= PieceValues[ nUpgrade ] - PieceValues[ WPAWN ];
					 if (nUpgrade < 5 ) Board.nBMinors++;
					 Board.nBP++;
					 Board.nBPawns--;
					 nPType += (nUpgrade - WPAWN); 
					}
			}

        // Do the Move on the board
        Board.Sq[ dst ] = nPType;
        Board.Sq[ src ] = EMPTY;
        if (Board.SideToMove == WHITE ) Board.BPiece[ nPiece ] = dst;
			else Board.WPiece[ nPiece ] = dst;
                        
        return retVal;
        }
        
// ----------------------------------------------------------
// Check for a discovered attack on Sq from nDirection
// ----------------------------------------------------------
int inline CheckDirecBRQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == BROOK || Board[Sq] == BQUEEN) return Sq;
	return 0;
}
int inline CheckDirecBBQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == BBISHOP || Board[Sq] == BQUEEN) return Sq;
	return 0;
}
int inline CheckDirecWRQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == WROOK || Board[Sq] == WQUEEN) return Sq;
	return 0;
}
int inline CheckDirecWBQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == WBISHOP || Board[Sq] == WQUEEN) return Sq;
	return 0;
}
int inline CheckDirecBQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == BQUEEN) return Sq;
	return 0;
}
int inline CheckDirecWQ ( int Sq, const int &nDirec, const unsigned char Board[] )
{
	Sq+=nDirec;
	while (Board [Sq] == EMPTY) Sq+=nDirec;
	if (Board[Sq] == WQUEEN) return Sq;
	return 0;
}

// ----------------------------------------------------------
//
// Test for a Discovered check
//
// ----------------------------------------------------------
int DiscoveredCheck ( int color, SBoard &TempBoard, int Move )
	{
	 int bRetVal = FALSE;
     int srcSq = MSrc(Move); 
     int dstSq = MDst(Move); 

	 unsigned char cPiece = TempBoard.Sq [ srcSq ];
	 TempBoard.Sq [ srcSq ] = EMPTY;
	// Check Testing
	 if (color == BLACK)
		{
		int KingSq = TempBoard.BPiece[15];
		int nDirec = acDirec [ KingSq + (srcSq<<7) ];
		if (nDirec != 0 && nDirec != acDirec [ KingSq  + (dstSq<<7) ]) 
			{if (HoriDir [ nDirec + 12 ])
				{if (CheckDirecWRQ (KingSq , nDirec, TempBoard.Sq) != 0 ) bRetVal = TRUE;}
			 else {if (CheckDirecWBQ (KingSq , nDirec, TempBoard.Sq) != 0 ) bRetVal = TRUE;}
			}
		}
	 else
		{
		int KingSq = TempBoard.WPiece[15];
		int nDirec = acDirec [ KingSq + (srcSq<<7) ];
		if (nDirec != 0 && nDirec != acDirec [ KingSq  + (dstSq<<7) ]) 
			{if (HoriDir [ nDirec + 12 ])
				{if (CheckDirecBRQ (KingSq , nDirec, TempBoard.Sq) != 0 ) bRetVal = TRUE;}
			 else {if (CheckDirecBBQ (KingSq , nDirec, TempBoard.Sq) != 0 ) bRetVal = TRUE;}
			}
		}
	 TempBoard.Sq [ srcSq ] = cPiece;
	 return bRetVal;
	}

//
// ARgghhh... helpers for Checking Move. 
//
int inline DiscoverCheckW (const unsigned char Board[], const int Sq, const int KingSq, const int nDirec)
{
	int nDirecD = acDirec [ KingSq + (Sq<<7) ];
	if (nDirecD != 0 && nDirecD != nDirec) 
		{if (HoriDir [ nDirecD + 12 ]) 
			 return CheckDirecWRQ (KingSq , nDirecD, Board);
			 return CheckDirecWBQ (KingSq , nDirecD, Board);
		}
	return 0;
}

int inline DiscoverCheckB (const unsigned char Board[], const int Sq, const int KingSq, const int nDirec)
{
	int nDirecD = acDirec [ KingSq + (Sq<<7) ];
	if (nDirecD != 0 && nDirecD != nDirec) 
		{if (HoriDir [ nDirecD + 12 ])	
			return CheckDirecBRQ (KingSq , nDirecD, Board);
			else return CheckDirecBBQ (KingSq , nDirecD, Board); 
		}
	return 0;
}

// ----------------------------------------------------------
//
// Test to see if Move checks the enemy King
// (With all the special cases this dedicated checking move function isn't really worth
// the trouble yet... but it could be useful in the future if I make some other changes.)
//
// ----------------------------------------------------------
int CheckingMove( const int color, SBoard &TempBoard, const int Move, const int Type )
{
    int srcSq = MSrc(Move); 
    int dstSq = MDst(Move); 
	//
	// Ugg, Castling might make a rook check, so set dst to rook sq
	if (srcSq > 122)
		{
		if (srcSq == 124) dstSq = 97;
		if (srcSq == 125) dstSq = 95;
		if (srcSq == 126) dstSq = 27;
		if (srcSq == 127) dstSq = 25;
		}
	// ---------------
	int piece = TempBoard.Sq [dstSq];
	int bCheck = 0;
	int KingSq, nDirec; 

// WHITE moves
if (color == WHITE)
	{
	KingSq = TempBoard.BPiece[15];
	nDirec = acDirec [ (dstSq<<7) + KingSq];

	switch (piece)
		{
		case WPAWN:
			if (dstSq == KingSq+9 || dstSq == KingSq+11) bCheck++;
			//En Passant captures vacate 2 squares, so we have to have to check the captured piece square for discovered too
			//I wonder why this slows down the program so much.
			if ( Type==ENPASSANT) if (DiscoverCheckW (TempBoard.Sq, dstSq+10, KingSq, nDirec) !=0 ) bCheck++;
			break;
		case WBISHOP:
			if (DiagDir [ nDirec + 12 ]==1 && CheckDirecWBQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case WQUEEN:
			if (nDirec!=0 && CheckDirecWQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case WROOK:
			if (HoriDir [ nDirec + 12 ]==1 && CheckDirecWRQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case WKNIGHT:
			if (KnightAttacks [ dstSq - KingSq + 128 ] == 1) bCheck++;
			break;
		}

	if (srcSq > 122) return bCheck; // Can't discover on a castle

	// Discovered Checks
	if (DiscoverCheckW (TempBoard.Sq, srcSq, KingSq, nDirec) != 0) bCheck++;
	return bCheck;
	}

else // Same as above, except for BLACK
	{
	KingSq = TempBoard.WPiece[15];
	nDirec = acDirec [ (dstSq<<7) + KingSq];

	switch (piece)
		{
		case BPAWN:
			if (dstSq == KingSq-9 || dstSq == KingSq-11) bCheck++;
			//En Passant captures vacate 2 squares
			if ( Type==ENPASSANT) if (DiscoverCheckB (TempBoard.Sq, dstSq-10, KingSq, nDirec) != 0) bCheck++;
			break;
		case BBISHOP:
			if (DiagDir [ nDirec + 12 ]==1 && CheckDirecBBQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case BQUEEN:
			if (nDirec!=0 && CheckDirecBQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case BROOK:
			if (HoriDir [ nDirec + 12 ]==1 && CheckDirecBRQ ( KingSq, nDirec, TempBoard.Sq ) > 0) bCheck++;
			break;
		case BKNIGHT:
			if (KnightAttacks [ dstSq - KingSq + 128 ] == 1) bCheck++;
			break;
		}

	if (srcSq > 122) return bCheck; // Can't discover on a castle

	// Discovered Checks
	if (DiscoverCheckB (TempBoard.Sq, srcSq, KingSq, nDirec) !=0) bCheck++;
	return bCheck;
	}
}

// ------------------------
// DO MOVE
// Do a move on Board based on x,y Coordinates
// Returns 0 for illegal move, 1 for legal move
// ------------------------
int DoMoveXY (SBoard &Board, int x, int y, int x2, int y2, unsigned char color, unsigned char nPiece, int bAdd, STranscript *pTranscript, int &src, int &dst)
        {
        Movestruct BMoves;
        SBoard BoardTemp;
        int move = 255;
        int i, square, square2;
        int u1,u2;
        unsigned char ocolor;

        if (color == WHITE) ocolor = BLACK; else ocolor = WHITE;
        
        if (color == BLACK) FindMovesBlackCh (Board, BMoves);
                       else FindMovesWhiteCh (Board, BMoves); 

        square  = SQ (x, y);
        square2 = SQ (x2, y2);
        // Castling
		if (y != -1)
			{
	        if (Board.Sq [ square ] == WKING && (x2-x) == 2 && y == y2 && color == WHITE)  {square =124; square2 = 98;}
		    if (Board.Sq [ square ] == WKING && (x2-x) == -2 && y == y2 && color == WHITE) {square =125; square2 = 94;}
			if (Board.Sq [ square ] == BKING && (x2-x) == 2 && y == y2  && color == BLACK) {square =126; square2 = 28;}
			if (Board.Sq [ square ] == BKING && (x2-x) == -2 && y == y2 && color == BLACK) {square =127; square2 = 24;}
			}
        
		// Look for (x,y)-(x2,y2) move in movelist BMoves
		// x == -1 or y == -1 means they can be any value
        for (i = 1; i<= BMoves.nummoves + 50; i++)
                {
				if (i == BMoves.numAttackmoves + 1) i = 51;
				if (i > BMoves.nummoves + 50) break;
				// Test to make sure this move doesn't check yourself.
				BoardTemp = Board;
				Do_Move (BoardTemp, BMoves.Moves [i], u1, u2, WQUEEN); 
				if (IsCheck (color, BoardTemp) == 0)
					{
					// Test to see if this valid move matches data sent in.
					if (y == -1 || x == -1) // wildcards?
						{
						if ( x == -1 || SQFILE[ MSrc(BMoves.Moves[i]) ] == (x+1) )
							if ( y == -1 || SQRANK[ MSrc(BMoves.Moves[i]) ] == (8 - y) )
								if ( MDst(BMoves.Moves[i]) == square2 && Board.Sq [ MSrc(BMoves.Moves[i]) ] == nPiece)
									move = i;
						}
					else
						{
						if (MSrc(BMoves.Moves[i]) == square && MDst(BMoves.Moves[i]) == square2 )
							move = i;
						}
					}
                }
        
        if (move == 255) return FALSE; // move not found, thus not a valid Move

		// src & dst are passed in as reference, so fill them in
		src = MSrc(BMoves.Moves [move]);
		dst = MDst(BMoves.Moves [move]);

		// If user must choose the upgrade type
		if (upgrade == 0 && src < 120 && (Board.Sq [ src ]&7) == WPAWN && ( SQRANK[dst]==8 || SQRANK[dst]==1) )
                    {// user prompted to input promoted piece type
					 HINSTANCE hinst = (HINSTANCE)GetWindowLong( mainhwnd, GWL_HINSTANCE ); 
                     DialogBox( hinst ,"Pawn", mainhwnd, (DLGPROC) PawnDlgProc);
                    }
                       
		// Do the Move
		BoardTemp = Board;

		Do_Move (Board, BMoves.Moves [move], u1, u2, upgrade);
        if (bAdd == TRUE) 
			{
			AddTranscript ( pTranscript, BMoves.Moves, move, BoardTemp);
			}
             
        return TRUE;
        }