// Slow Chess 
// by Jonathan Kreuzer
// copyright 2003
// Opening Book Functions at Bottom

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "data.h"
#include "gui.h"
#include "moves.h"
#include "search.h"
#include "transcript.h"
#include "scNet.h"

extern HWND mainhwnd, sideHWND;
extern clock_t g_startTime; // from gui.cpp

STranscript *Transcript = (STranscript *) calloc (sizeof (STranscript), 1);

// --------------------
// Read a Piece from a char to the defines used by slow chess
// --------------------
int GetPiece ( char cTest, unsigned char &cPiece, int lwr)
{
if ( cTest == 'p' ) {cPiece = WPAWN; return 1; }
if ( cTest == 'K' ) {cPiece = WKING;   return 1; }
if ( cTest == 'N' || (cTest == 'n' && lwr == TRUE) ) {cPiece = WKNIGHT; return 1; }
if ( cTest == 'B' || (cTest == 'b' && lwr == TRUE)  ) {cPiece = WBISHOP; return 1; }
if ( cTest == 'Q' || (cTest == 'q' && lwr == TRUE)  ) {cPiece = WQUEEN;  return 1; }
if ( cTest == 'R' || (cTest == 'r' && lwr == TRUE)  ) {cPiece = WROOK;   return 1; }
return 0;
}

// --------------------
// Get Move XY PGN
// --------------------
void GetMoveXYPGN (char textline[], SBoard &Board, int &sX, int &sY, int &dX, int &dY, unsigned char &piece)
{
int y = 0;
// Castling?
	 if ( ( textline[y] == 'o' || textline [ y ] == 'O' || textline [ y ] == '0' ) && ( textline [ y + 1 ] == '-' ) && (textline [ y + 2 ] == 'o' || textline [ y + 2] == 'O' || textline [ y + 2 ] == '0') )
			{
			if (Board.SideToMove == WHITE) {sX = (Board.WPiece[15]-22)%10; sY = (Board.WPiece[15]-22)/10;}
			if (Board.SideToMove == BLACK) {sX = (Board.BPiece[15]-22)%10; sY = (Board.BPiece[15]-22)/10;}
			dY = sY;
			if (textline [ y+3 ] == '-' && (textline [ y+4 ] == 'o' || textline [ y+4 ] == 'O' || textline [ y+4 ] == '0' ) )
				 dX = sX - 2;
			else dX = sX + 2;
			return;
			}

upgrade = WQUEEN; 
// Piecetype to dst moves
piece = WPAWN;
 sX = -1; sY = -1;  dX = -1;   dY = -1;
y += GetPiece ( textline[y], piece, FALSE );
if ( Board.SideToMove == BLACK) piece+=8;

if ( textline[y] == 'x' || textline[y] == '-')  { y++; }
if ( textline[y] >= 'a' && textline[y] <= 'h' ) { dX = textline[y] -'a'; y++ ; }
if ( textline[y] == 'x' || textline[y] == '-')  { y++; }
if ( textline[y] >= '1' && textline[y] <= '8' ) { dY = '8'-textline[y];  y++ ; }
if ( textline[y] == 'x' || textline[y] == '-')  { y++; }
if ( textline[y] >= 'a' && textline[y] <= 'h' ) { sX = dX; dX = textline[y] -'a'; y++; }
if ( textline[y] >= '1' && textline[y] <= '8' ) { sY = dY; dY = '8' - textline[y]; y++; }

// upgrade type?
if (textline[y] == '=') y++;
y+=GetPiece ( textline[y], upgrade, TRUE );
}

// --------------------
// Do a move spefified by text textline (PGN format)
// --------------------
int DoMovePGN(char textline[], SBoard &Board, int bAddTran, STranscript *pTranscript)
	{
	int sX = 1, sY = 1, dX = 1, dY = 1, nTemp, nTemp2;
	unsigned char piece;

	GetMoveXYPGN ( textline, Board, sX, sY, dX, dY, piece);

	if (dX !=-1 && dY !=-1)
		return DoMoveXY (Board, sX, sY, dX, dY, Board.SideToMove, piece, bAddTran, pTranscript, nTemp, nTemp2);

	return 0;
	}


//
// SkipComments, etc...
//
int NextChar ( char text[], int &y, int nLength )
{
	int depth = 0;
	y++;

	if ( text[y] == '$' )
		{
		y++;
		while ( text[y] >= '0' && text[y] <= '9'  && y<nLength ) y++;
		return y;
		}

	if ( text[y] == '(' ) 
		{
		depth++;
		y++;
		while ( depth > 0 && y<nLength)
			{
			if ( text[y] == '(' ) depth++;
			if ( text[y] == ')' ) depth--;
			y++;
			}
		}

	if ( text[y] == '[' ) 
		{
		depth = 1;
		y++;
		while ( depth > 0 && y<nLength)
			{
			if ( text[y] == '[' ) depth++;
			if ( text[y] == ']' ) depth--;
			y++;
			}
		}

	if ( text[y] == '{' ) 
		{
		depth++;
		y++;
		while ( depth > 0 && y<nLength)
			{
			if ( text[y] == '{' ) depth++;
			if ( text[y] == '}' ) depth--;
			y++;
			}
		}

	return y;
}

// --------------------
// Replay an entire transcript
// --------------------
void GetMovesPGN(char text[], int bDoMove)
{
char sMove [ 40 ];
int y = 0, x;
int nLength = 0;

while (text [y++] != NULL) nLength++;

y = -1;
NextChar (text, y, nLength);

	while (y < nLength) 
		{
		if ( text[y] >= '0' && text[y] <= '9' )
			{
			NextChar (text, y, nLength);
			while ( text[y] >= '0' && text[y] <= '9' ) NextChar (text, y, nLength);
			if ( text[y] == '.') NextChar (text, y, nLength);
			while ( (text[y] == ' ' || text[y] <= 13) ) NextChar (text, y, nLength);
			x = 0;
			while ( (text[y] != ' ' && text[y] > 13) && x < 39)  
				{sMove [ x++ ] = text [ y ];
				 NextChar (text, y, nLength);
				}
			sMove [x++] = NULL;
			DoMovePGN ( sMove, GameBoard, TRUE, Transcript );

			while ( (text[y] == ' ' || text[y] <= 13) ) NextChar (text, y, nLength);
			x = 0;
			while ( (text[y] != ' ' && text[y] > 13 )  && x < 39)
				{
				 if (text[y] == '.' ) 
					{
					 while (text[y] == '.' || text[y] == ' ' || text[y] <= 13 )
						 NextChar (text, y, nLength);
					 x = 0;
					}
				 sMove [ x++ ] = text [ y ];
				 NextChar (text, y, nLength);
				}
			sMove [x++] = NULL;

			DoMovePGN ( sMove, GameBoard, TRUE, Transcript  );
			}
		NextChar (text, y, nLength);
		}

}


// ============================================
//
// Add Moves to Transcript
// Use the Transcript to Take Back and Redo Moves
//
// ============================================
void ClearTranscript ( STranscript *pTranscript )
{
	if ( pTranscript == NULL || pTranscript == Transcript) 
		{
		pTranscript = Transcript;
		}
	ZeroMemory ( pTranscript, sizeof ( STranscript ) );
}

// --------------------
void GetLastMoveTranscript ( char **sMove )
	{
	 *sMove = Transcript->Moves [ Transcript->nMoves-1 ];
	}

// ----------------------
//   Add Move to Game Transcript
// ----------------------
void AddTranscript (STranscript *pTranscript, int Moves[], int movenum, SBoard &Board)
        {
          int src, dst;
		  int x = 0;
		  char *sMove;

		  if (pTranscript == NULL) pTranscript = Transcript;

		  if (pTranscript->nMoves + 4 >= MAX_MOVES)
			{
			  DisplayText ("Hit Maximum Move Number");
			  return;
			}

		  src = MSrc(Moves [movenum]);
          dst = MDst(Moves [movenum]);

		  // This also means a new move in the game
		  if (pTranscript == Transcript) // update main info but only on main transcript
			{
			if (Board.GameTime >= pTranscript->nMoves)
				{
				clock_t endTime = clock ();
				if ((Board.GameTime % 2) == 1 )  g_nWhiteTime += (100*(endTime - g_startTime))/CLOCKS_PER_SEC;
					else g_nBlackTime += (100*(endTime - g_startTime))/CLOCKS_PER_SEC;
				}
			g_startTime = clock ();

		    // Repetition Board
            AddRepBoard( Board );
			g_GameResult = NONE;
			}
       
		  pTranscript->nMoves = Board.GameTime;

		  sMove = pTranscript->Moves [ Board.GameTime - 1 ];
         
		  sMove [ 6 ] = NULL;
		  sMove [ 7 ] = NULL;

          if (src == 124 || src == 126) 
				{
				 strcpy (sMove, "O-O   ");
                 return;
				}
          if (src == 125 || src == 127) 
				{
			     strcpy (sMove, "O-O-O ");
                 return;
				}
          
		  sMove [ x++ ] = PieceChars [ Board.Sq[src]&7 ];
		  if (sMove [ 0 ] == 'p') x = 0;
          sMove [ x++ ] = ((src - 22) % 10) + 'a';
          sMove [ x++ ] = '8' - ((src - 22) / 10);
          if (Board.Sq [dst] == EMPTY) sMove [ x++ ] = '-'; else sMove [ x++ ] = 'x';
          sMove [ x++ ] = ((dst - 22) % 10) + 'a';
          sMove [ x++ ] = '8' - ((dst - 22) / 10);
          if ( (Board.Sq[src]&7) == WPAWN && (((dst - 22) / 10) == 7 || ((dst - 22) / 10) == 0) )
			{
			  sMove[ x++ ] = '=';
              sMove [ x++ ] = PieceChars [ upgrade ];
			}
		  while (x < 6) sMove [ x++ ] = ' ';

         }
// ----------------------
// Returns True the the Board is current with the transcript.
// ----------------------
int CurrentBoard ( SBoard &Board )
{
 if (Transcript->nMoves >= Board.GameTime ) return FALSE;
			else return TRUE;
}
// ----------------------
// Returns number of moves in the Transcript
// ----------------------
int NumTranMoves ( )
{
 return Transcript->nMoves;
}
// ----------------------
//  Replay Game up to move number nEnd
// ----------------------
void ReplayGame ( SBoard &Board, int nEnd)
     {
	  int i = 0;
	  Board = g_StartBoard;
	  while ( i < (nEnd-1) && i < Transcript->nMoves )
			{
			DoMovePGN ( Transcript->Moves [ i ], Board, FALSE, NULL );
			i++;
			}
      }

// ============================================
//
// Update Transcript ListBox after making a move
//
// ============================================
void UpdateListTranscript ( int bUpdateList )
{
    HWND hwndList = GetDlgItem(sideHWND, 109);
	char buffer [ 80 ];

	int gametime = (GameBoard.GameTime/2);

	if (bUpdateList == TRUE)
		{
		if (GameBoard.SideToMove == BLACK && gametime-1 >= SendMessage (hwndList, LB_GETCOUNT, 0, 0 ) )
			{
			sprintf (buffer, "%d. %s ", gametime, Transcript->Moves[GameBoard.GameTime - 2]);
			SendMessage (hwndList, LB_ADDSTRING, 0, (LPARAM)buffer );
			}
           
		if (GameBoard.SideToMove == WHITE  && gametime >= SendMessage (hwndList, LB_GETCOUNT, 0, 0 ))
			{
			SendMessage (hwndList, LB_DELETESTRING, gametime-1, 0 );
			sprintf (buffer, "%d. %s  |  %s", gametime, Transcript->Moves[GameBoard.GameTime - 3 ], Transcript->Moves[ GameBoard.GameTime - 2 ] );
			SendMessage (hwndList, LB_ADDSTRING, 0, (LPARAM)buffer );
			}
		}

	int nSel = (GameBoard.GameTime / 2) -1;
	if (nSel < 0) nSel = 0;
	SendMessage (hwndList, LB_SETCURSEL, nSel, 0 );
 }


//
// Update Transcript ListBox after loading a game
//
void MoveBox ( int i )
    {
    char buffer[60];

    HWND hwndList;
    hwndList = GetDlgItem(sideHWND, 109);
    SendMessage (hwndList, LB_RESETCONTENT, 0, 0 );
   
	int gametime;
    for (gametime = 0; gametime < i; gametime+=2)
        {
		sprintf (buffer, "%d. %s  |  %s", gametime/2 + 1, Transcript->Moves[gametime], Transcript->Moves[gametime + 1] );
        SendMessage (hwndList, LB_ADDSTRING, 0, (LPARAM)buffer );
        }

	if ((i%2) == 0)
       {
	   sprintf (buffer, "%d. %s ", gametime/2 + 1, Transcript->Moves[gametime]);
       SendMessage (hwndList, LB_ADDSTRING, 0, (LPARAM)buffer );
       }

	int nSel = (i / 2);
	if (nSel < 0) nSel = 0;
	SendMessage (hwndList, LB_SETCURSEL, nSel, 0 );
 }

//
// Remove a move from the transcript list box.
//
void TrimList (void)
        {
		 if (g_bWinBoard == TRUE) return;
		 int i;
         HWND hwndList;
         hwndList = GetDlgItem(sideHWND, 109);
         
		if ( (GameBoard.GameTime/2) - 2 < SendMessage (hwndList, LB_GETCOUNT, 0, 0 ) )
                for (i= SendMessage (hwndList, LB_GETCOUNT, 0, 0 ); i >= (GameBoard.GameTime/2); i--)
                        SendMessage (hwndList, LB_DELETESTRING, i, 0 );

		if (GameBoard.SideToMove == WHITE)
                {
				strcpy (Transcript->Moves [ GameBoard.GameTime + 2 ], "");
                }
         else
               {
				strcpy (Transcript->Moves [ GameBoard.GameTime + 1 ], "");
                SendMessage (hwndList, LB_DELETESTRING, i, 0 );
                }
        }

// ============================================
// Copy Transcipt from stored format to text string format
// ============================================
int CopyTranscript (STranscript *Transcript, char *clipText, int nMaxLen)
	{
	int nLen = 0;
    for (int i = 0; i < Transcript->nMoves && (nLen + 14) < nMaxLen; i++ )
            {
			if ( (i%2) == 0 ) nLen += sprintf ( clipText + nLen , "%d. ", (i/2) + 1);
			nLen += sprintf ( clipText + nLen , "%s ", Transcript->Moves [ i ] );
		    if ( (i%2) == 1 ) nLen += sprintf ( clipText + nLen , "\n" );
			clipText [ nLen ] = NULL;
            }
	return nLen;
	}

// ============================================
//
// Paste a Transcript from the windows clipboard
//
// ============================================
void ClipPasteTranscript ( HWND hwnd, int bPos )
{
    if (!IsClipboardFormatAvailable(CF_TEXT)) return;

	// Open clipboard and Get Data in clipText
    OpenClipboard(hwnd);
    HANDLE hData = GetClipboardData(CF_TEXT);
    LPVOID pData = GlobalLock(hData);
	int nSize = strlen ( (char *) pData);
	char *clipText = (char *) malloc ( nSize + 1 );
	memcpy (clipText, (LPSTR)pData, nSize );
    GlobalUnlock(hData);
    CloseClipboard();

	if (bPos == FALSE)
		{
		// Replay the game from the Transcript
		NewGame ( FALSE );
		GetMovesPGN ( clipText, TRUE );
		MoveBox ( GameBoard.GameTime - 2 );
		UpdateListTranscript ( FALSE );
		UpdateMove( FALSE );
		}
	else
		{
		// Set the board from a FEN position
		SetBoardFromText ( clipText, nSize );
		UpdateListTranscript ( FALSE );
		}

	free ( clipText );
}
// ============================================
//
// Copy a Transcript (or Position) to the windows clipboard
//
// ============================================
void ClipCopyTranscript ( HWND hwnd, int bPos)
{
		int nLen;
		char *clipText = (char *) malloc ( 10000 );
		char *bufferPtr;
		static HGLOBAL clipTranscript;     
 
		if (bPos == FALSE) nLen = CopyTranscript (Transcript, clipText, 10000);
			else nLen = CopyPosition (clipText, GameBoard);

		if (OpenClipboard( hwnd) == TRUE)
			{
			EmptyClipboard();
			clipTranscript = GlobalAlloc (GMEM_DDESHARE | GMEM_MOVEABLE , nLen + 10);
			bufferPtr = (char*) GlobalLock (clipTranscript);
			memcpy(bufferPtr, clipText, nLen + 1);
			GlobalUnlock( clipTranscript );
			SetClipboardData(CF_TEXT, clipTranscript);
			CloseClipboard(); 
			}
		else SetDlgItemText (sideHWND, 122, "Cannot Open Clipboard");

		free ( clipText );
}

// ============================================
//
// Save and Load Transcripts
//
// ============================================

// ------------------------
// Save Game Transcript to Disk
// ------------------------
void SaveGame (int gameResult, char buffer[], int bAppend)
  {
  FILE *fp;
  char *sNone = "Unknown";
  char *sWhiteName, *sBlackName;
  char sResult[20];
  char sFEN [ 200 ];
  int nBlackELO = 0, nWhiteELO = 0;

  if (g_bNetGame == TRUE) 
	{
	  PlayerCOLOR = g_cNetColor;
	  sWhiteName = g_sNetWhite;
	  sBlackName = g_sNetBlack;
	}
  else 
	{
	strcpy (sOppName , g_sSlow);

	if (PlayerCOLOR == WHITE) 
		{
		sWhiteName = sUserName; 
		nWhiteELO = ELO;
		sBlackName = sOppName;
		}

	if (PlayerCOLOR == BLACK) 
		{
		sWhiteName = sOppName;  
		sBlackName = sUserName;
		nBlackELO = ELO;
		}
	if (PlayerCOLOR == NONE)
		{
		sWhiteName = g_sSlow;  
		sBlackName = g_sSlow;
		}

	if (PlayerCOLOR == BOTH)
		{
		sWhiteName = sUserName;  
		sBlackName = sUserName;
		}
	}
       
  if (bAppend == TRUE) fp = fopen (buffer, "at");
		else fp = fopen (buffer, "wt");
       
   struct tm *newtime;
   time_t long_time;
   time( &long_time );              
   newtime = localtime( &long_time ); 
   int year = newtime->tm_year;
   year+=1900;

   if (gameResult == WHITEWINS ) sprintf (sResult, "1-0");
   else if (gameResult == BLACKWINS ) sprintf (sResult, "0-1");
   else if (gameResult == DRAW ) sprintf (sResult, "1/2-1/2");
   else sprintf (sResult, "*"); // Unknown, in progress, or abandoned.
  
   if (fp==NULL)
	{
	   DisplayText ("Cannot Open File.");
	   return;
	}
 
   if (g_bNetGame == FALSE) fprintf (fp, "[Event \"Slow Chess Game\"]\n");
		else fprintf (fp, "[Event \"Net Game\"]\n");
	fprintf (fp, "[Date \"%d/%d/%d\"]\n", newtime->tm_mon + 1, newtime->tm_mday, year );
	fprintf (fp, "[Time \"%.2d:%.2d:%.2d\"]\n", newtime->tm_hour, newtime->tm_min, newtime->tm_sec);
	if (g_bNetGame == TRUE) fprintf (fp, "[TimeControl \"%d+%d\"]\n", g_NetMinutes * 60, g_NetSeconds);
		else fprintf (fp, "[TimeControl \"%d+%d\"]\n", Minutes * 60, Seconds);
	fprintf (fp, "[Current Ply \"%d\"]\n", GameBoard.GameTime );
	fprintf (fp, "[White \"%s\"]\n", sWhiteName );
	fprintf (fp, "[Black \"%s\"]\n", sBlackName );
	if (nBlackELO!=0 ) fprintf (fp, "[BlackElo \"%d\"]\n", nBlackELO );
	if (nWhiteELO!=0 ) fprintf (fp, "[WhiteElo \"%d\"]\n", nWhiteELO );
	fprintf (fp, "[Result \"%s\"]\n", sResult );
	// Started from a FEN position?
	SBoard TempBoard;
	Setup_Board (TempBoard, 0);
	if (memcmp ( &TempBoard, &g_StartBoard, sizeof (SBoard)) != 0)
		{
		 CopyPosition ( sFEN, g_StartBoard );
		 fprintf (fp, "[FEN \"%s\"]\n", sFEN );
		 fprintf (fp, "[SetUp \"1\"]\n");
		}
	fprintf (fp, "\n");
	// Write out the moves
    for (int i = 0; i < Transcript->nMoves; i++)
           {
			if ( (i%2) == 0 ) fprintf ( fp, "%d. ", i/2 + 1 );
			fprintf ( fp, "%s ", Transcript ->Moves [ i ]);
            if ( (i%2) == 1 ) fputc ('\n', fp);
           }
	fprintf ( fp, "\n\n", i );
	fclose (fp);
  }

void ReadString ( char *sIn, char *sOut)
{
int x = 0;
	while ( sIn[x] != '\"' )
		{
		sOut[x] = sIn[x];
		x++;
		}
	sOut[x] = NULL;
}


void SGameInfo::Reset ( )
	{
	tempTime = -1;
	strcpy (sWhitePlayer, "X");
	strcpy (sBlackPlayer, "X");
	strcpy (sResult, "X");
	strcpy (sTimeControl, "X");
	strcpy (sFEN, ""); 
	}
//
// Read a Game, return true if there's another game afterwards
//
int ReadGame ( char *cliptext, FILE *fp, SGameInfo &Info)
	{
	    char *pS;

		Info.Reset();
		int i = 0;
		fgets (cliptext, MAX_LEN, fp);
		while ( cliptext[0] == '[' )
			{
			if (strstr ( cliptext, "Current Ply" ) != NULL )
				sscanf ( cliptext, "[Current Ply \"%d\"]", &Info.tempTime);
		    if ( (pS = strstr ( cliptext, "White \"" )) != NULL )
				ReadString ( pS + 7, Info.sWhitePlayer);
		    if ( (pS = strstr ( cliptext, "Black \"" )) != NULL )
				ReadString ( pS + 7, Info.sBlackPlayer);
		    if ( (pS = strstr ( cliptext, "Result \"" )) != NULL )
				ReadString ( pS + 8, Info.sResult);
			if ( (pS = strstr ( cliptext, "Event \"" )) != NULL )
				ReadString ( pS + 7, Info.sEvent);
			if ( (pS = strstr ( cliptext, "TimeControl \"" )) != NULL )
				ReadString ( pS + 13, Info.sTimeControl);
			if ( (pS = strstr ( cliptext, "FEN \"" )) != NULL )
				ReadString ( pS + 5, Info.sFEN);
			fgets (cliptext, MAX_LEN , fp);
			}

		while (!feof (fp ) && i < MAX_LEN )
			{
			cliptext[ i ] = (char) fgetc ( fp );
			if (cliptext[ i ] == NULL) cliptext [ i ] = 32;
			if (cliptext[ i-5 ] == '[' && cliptext[ i-4 ] == 'E' && cliptext[ i-3 ] == 'v' && cliptext[ i-2 ] == 'e' && cliptext[ i-1 ] == 'n' )
				{
				cliptext [ i ] = NULL;
				fseek ( fp, -6 , SEEK_CUR);
				return TRUE;
				}
			i++;
			}
		cliptext [ i ] = NULL;
		return FALSE;
	}


// ------------------------
// Load Transcript From Disk
// ------------------------
int LoadGame ( char buffer[],  int nGame, int bDisplay)
        {
        FILE *fp;
		SGameInfo Info;
		
        fp = fopen (buffer, "rt");
        if (fp == NULL) return 0;
 
		char *cliptext = (char* ) malloc ( MAX_LEN + 1 );

		int numGames = 1;
		while ( ReadGame ( cliptext, fp, Info) == TRUE && numGames < nGame )
			{
			numGames++;
			}

		fclose (fp);

		NewGame( FALSE ); // Set board to start position
		// Set positon from FEN if there is one.
		if (Info.sFEN[0]!=NULL) SetBoardFromText (Info.sFEN, strlen ( Info.sFEN ) );

		GetMovesPGN ( cliptext, TRUE ); // Read in ( &play) the moves

		MoveBox ( GameBoard.GameTime - 2 );

		free (cliptext);

		if (Info.tempTime != -1)
			{
			ReplayGame (GameBoard, Info.tempTime);
			}

		char TempBuffer [400];
		if (bDisplay == TRUE)
			{
			sprintf ( TempBuffer, "Game %d\nEvent: %s\nTime Control: %s\nWhite: %s\nBlack: %s\nResult: %s\n", numGames, Info.sEvent, Info.sTimeControl, Info.sWhitePlayer, Info.sBlackPlayer, Info.sResult);
			DisplayText ( TempBuffer );
			}

        return numGames;
        }

// ------------------------
// Setup Board from a text position
// 8/4K2p/6pr/5pk1/1pB2R2/p4PP1/8/8 w - - 
// ------------------------
int SetBoardFromText ( char *Text, int nLen )
	{
	 int i = 0;
	 int sq = 0;
	 SBoard Board;

	 ClearBoard ( Board );
	 Board.SideToMove = NONE;

	 while (sq < 64 && i<nLen)
		{
		if ( Text[i]>='1' && Text[i]<='8'  ) sq+= Text[i]-'0' - 1;
		else if ( Text[i] == 'K') AddPiece (Board, sq%8, sq/8, WKING);
		else if ( Text[i] == 'k') AddPiece (Board, sq%8, sq/8, BKING);
		else if ( Text[i] == 'Q') AddPiece (Board, sq%8, sq/8, WQUEEN);
		else if ( Text[i] == 'q') AddPiece (Board, sq%8, sq/8, BQUEEN);
		else if ( Text[i] == 'R') AddPiece (Board, sq%8, sq/8, WROOK);
		else if ( Text[i] == 'r') AddPiece (Board, sq%8, sq/8, BROOK);
		else if ( Text[i] == 'B') AddPiece (Board, sq%8, sq/8, WBISHOP);
		else if ( Text[i] == 'b') AddPiece (Board, sq%8, sq/8, BBISHOP);
		else if ( Text[i] == 'N') AddPiece (Board, sq%8, sq/8, WKNIGHT);
		else if ( Text[i] == 'n') AddPiece (Board, sq%8, sq/8, BKNIGHT);
		else if ( Text[i] == 'P') AddPiece (Board, sq%8, sq/8, WPAWN);
		else if ( Text[i] == 'p') AddPiece (Board, sq%8, sq/8, BPAWN);
		else if ( Text[i] == '/') { while ( (sq&7) !=0 ) sq++;
									sq --;
									}
		else sq--;
		sq++;
		i++;
		}

	 Board.BCastle = 3;
	 Board.WCastle = 3;
	 while (i<nLen && Text[i]!='-')
		{
		 if ( Text[i] == 'w') { Board.SideToMove = WHITE;}
		 if ( Text[i] == 'b') { Board.SideToMove = BLACK; Board.GameTime++;}
		 if ( Text[i] == 'K') { Board.WCastle &= 1;}
		 if ( Text[i] == 'Q') { Board.WCastle &= 2;}
		 if ( Text[i] == 'k') { Board.BCastle &= 1;}
		 if ( Text[i] == 'q') { Board.BCastle &= 2;}
		 i++;
		}

	 if (sq >=64 && Board.SideToMove != NONE && Board.WPiece [15]!=CAPTURED && Board.BPiece[15]!=CAPTURED)
		{
		 NewGame ( FALSE );
		 g_StartBoard = Board;
		 GameBoard = Board;
		 UpdateMove( FALSE );
		 MoveBox ( 0 );
		 DisplayText ("Position Pasted.");
		 return TRUE;
		}
	 DisplayText ("Not a valid Position");
	 return FALSE;
	}

// ------------------------
// Convert Board to a FEN string
// ------------------------
const char   cPieces[17]  = { '.', '.', 'P', 'B', 'N', 'R', 'Q', 'K','.', '.', 'p', 'b', 'n', 'r', 'q', 'k', '.' };   

int CopyPosition ( char *Text, SBoard Board )
	{
	int index = 0, empty;
	char cPiece;

	// Board
	for (int y = 0; y<8; y++)
		{
		empty = 0;
		for (int x = 0; x<8; x++)
			{
			cPiece = Board.Sq[ SQ(x,y)];
			if (cPiece == EMPTY) empty++;
			else
				{
				if ( empty!=0 ) Text[index++] = empty+'0';
				Text[index++] = cPieces [ cPiece  ];
				empty = 0;
				}
			}
		if (empty != 0) Text[index++] = empty+'0';
		if (y!=7) Text[index++] = '/';
		}

	// Castling Flags
	Text[index++] = ' ';
	if (Board.SideToMove == WHITE) Text[index++] = 'w'; else Text[index++] = 'b';
	Text[index++] = ' ';
	if (Board.WCastle == 3 || Board.WCastle == 4) if (Board.BCastle == 3 || Board.BCastle == 4) Text[index++] = '-';
	if (Board.WCastle == 2) Text[index++] = 'Q';
	if (Board.WCastle == 1) Text[index++] = 'K';
	if (Board.WCastle == 0) {Text[index++] = 'K';Text[index++] = 'Q';}
	if (Board.BCastle == 2) Text[index++] = 'q';
	if (Board.BCastle == 1) Text[index++] = 'k';
	if (Board.BCastle == 0) {Text[index++] = 'k'; Text[index++] = 'q';}
	Text[index++] = ' ';
	Text[index++] = '-';
	Text[index] = NULL;

	return index;
	}




// ============================================
//
//   OPENING BOOK Functions. 
//
// ============================================
void COpeningBook::AddPosition ( SBoard &Board, short wValue, int bQuiet )
{
 unsigned long ulKey   = Hash_Board  ( Board );
 unsigned long ulCheck = Hash_Board2 ( Board );
 AddPosition (ulKey, ulCheck, wValue, bQuiet );
}

//
//
int COpeningBook::GetValue ( SBoard &Board )
{
 unsigned long ulKey   = Hash_Board  ( Board );
 unsigned long ulCheck = Hash_Board2 ( Board );

 int nEntry = ulKey&131071;
 SBookEntry *pEntry;

 pEntry = &m_pHash[ nEntry ];
 while (pEntry != NULL && pEntry->wValue != NOVAL)
	{
	if (pEntry->ulCheck == ulCheck  && pEntry->wKey == (ulKey>>16) )
		{
		return pEntry->wValue;
		}
	pEntry = pEntry->pNext;
	}

return NOVAL;
}
//
//
//
void COpeningBook::AddPosition ( unsigned long ulKey,  unsigned long ulCheck, short wValue, int bQuiet )
{
 char sTemp[ 255 ];
 int nEntry = ulKey&131071;

 SBookEntry *pEntry = &m_pHash[ nEntry ]; 

 while (pEntry->wValue != NOVAL)
	{
	if (pEntry->ulCheck == ulCheck && pEntry->wKey == (ulKey>>16) )
		{
		if (bQuiet != TRUE) 
			{
			 sprintf ( sTemp, "Position Exists. %d\nValue was %d now %d", nEntry, pEntry->wValue, wValue);
	 		 DisplayText ( sTemp );
			}
		if (wValue == 101 && pEntry->wValue > 100) pEntry->wValue++; // counting for pgn add
			else pEntry->wValue = wValue; 
		return;
		}
	if (pEntry->pNext == NULL)
		{
		if (m_nListSize >= BOOK_EXTRA_SIZE)
			{
			DisplayText ("Book Full!");
			return;
			}
		pEntry->pNext = &m_pExtra[ m_nListSize ];
		m_nListSize++;
		}
	pEntry = pEntry->pNext;
	}

 // New Position
 m_nPositions++;
 pEntry->ulCheck = ulCheck;
 pEntry->wKey = unsigned short (ulKey>>16);
 pEntry->wValue = wValue;
 if (bQuiet != TRUE)
	{
	sprintf ( sTemp, "Position Added. %d\nValue %d", nEntry, wValue);
	DisplayText ( sTemp );
	}
}

// ----------------------------------
//  Remove a position from the book.
//  (if this position is in the list, it stays in memory until the book is saved and loaded.)
// ----------------------------------
void COpeningBook::RemovePosition ( SBoard &Board, int bQuiet )
{
 char sTemp[ 255 ];
 unsigned long ulKey   = Hash_Board  ( Board );
 unsigned long ulCheck = Hash_Board2 ( Board );
 int nEntry = ulKey&131071;
 SBookEntry *pEntry = &m_pHash[ nEntry ];
 SBookEntry *pPrev = NULL; 

 while (pEntry != NULL && pEntry->wValue != NOVAL)
	{
	if (pEntry->ulCheck == ulCheck && pEntry->wKey == (ulKey>>16) )	
		{
		m_nPositions--;
		if (bQuiet != TRUE)
			{
			sprintf ( sTemp, "Position Removed. %d\nValue was %d", nEntry, m_pHash [ nEntry ].wValue);
			DisplayText ( sTemp );
			}
		if (pPrev != NULL) pPrev->pNext = pEntry->pNext;
			else 
				{
				if (pEntry->pNext != NULL) *pEntry = *pEntry->pNext;
					else pEntry->wValue = NOVAL;
				}
		return;
		}
	 pPrev = pEntry;
	 pEntry = pEntry->pNext;
	}

  if (bQuiet != TRUE)
	{
	 sprintf ( sTemp, "Position does not exist. %d\n",nEntry);
	 DisplayText ( sTemp );
	}

}

// --------------------
//
// FILE I/O For Opening Book
//
// --------------------

// LOAD
int COpeningBook::Load ( char *sFileName )
{
 FILE *fp;
 SBookEntry TempEntry;
 int i = 0;
 char sTemp[ 255 ];

 if ( (fp = fopen (sFileName, "rb")) == NULL) 
	{
	MessageBox (mainhwnd, "Error Loading Opening Book", "File Missing", MB_OK);
	return FALSE;
	}
  
  unsigned long wKey = TempEntry.Load ( fp );
  while (!feof ( fp ) )
	{
	  i++;
	  wKey += (TempEntry.wKey << 16);
	  AddPosition ( wKey, TempEntry.ulCheck, TempEntry.wValue, TRUE );
	  wKey = TempEntry.Load ( fp );
	}

  fclose ( fp );

  sprintf ( sTemp, "%d Positions Loaded", i);
  DisplayText ( sTemp );
  return TRUE;
}

//
// SAVE
//
// the book generation code muddles this up a bit, nTimes is 
// the number of times this position must have occured to be saved.
//
void COpeningBook::Save ( char *sFileName, int nTimes )
{
 FILE *fp;
 fp = fopen (sFileName, "wb");
 SBookEntry *pEntry;
 int Num = 0;
 nTimes+=100;
 
 for (int i = 0; i < 131072; i++)
	{
	 pEntry = &m_pHash [ i ];
	 if (pEntry->wValue != NOVAL)
			{
			if (pEntry->wValue >= nTimes) pEntry->wValue = 0;
			if (pEntry->wValue < 100 ) {
				 pEntry->Save ( fp, i );
				 Num++;}
	
			while (pEntry->pNext != NULL)
				{
				pEntry = pEntry->pNext;
				if (pEntry->wValue >= nTimes) pEntry->wValue = 0;
				if (pEntry->wValue < 100) {
					 pEntry->Save ( fp, i );
					 Num++;}
				}
			}
	}
  fclose ( fp );

  char sTemp[ 255 ];
  sprintf ( sTemp, "%d Positions Saved", Num);
  DisplayText ( sTemp );
}

// --------------------
//
// Find a Move from the opening Book
//
// Do all legal moves, then check to see if the position is in the opening book.
// --------------------
int COpeningBook::FindMoves ( SBoard &Board, int OutMoves[], short wValues[] )
{
int u1, u2, i, val, nFound;
Movestruct Moves;
SBoard TempBoard;

if (Board.SideToMove == WHITE)	FindMovesWhiteCh ( Board, Moves);
if (Board.SideToMove == BLACK)	FindMovesBlackCh ( Board, Moves);

upgrade = WQUEEN; 
nFound = 0;

for (i = 1; i<= Moves.nummoves + 50; i++)
	{
	TempBoard = Board;
	if (i == Moves.numAttackmoves + 1) i = 51;
	Do_Move ( TempBoard, Moves.Moves[i], u1, u2, WQUEEN );
	val = GetValue ( TempBoard );
	// Add move if it leads to a position in the book 
	// (and doesn't lead to a repeated position, since when storing positions this can happen.)
	if ( val != NOVAL && DrawByRepetition ( TempBoard ) == 0) 
		{
		OutMoves [nFound] = Moves.Moves [ i ];
		wValues[ nFound ] = val;
		nFound++;
		}
	}

return nFound;
}

// --------------------
// Try to do a move in the opening book
// --------------------
int COpeningBook::DoMove ( SBoard &Board )
{
 srand (clock()); // Randomize
 int nVal = NOVAL, nMove = -1;
 int u1, u2, nMax, i, nGood;
 int Moves [ 60 ];
 int GoodMoves [ 60 ];
 short wValues [60], wGoodVal [60];

 int nFound = FindMoves ( Board, Moves, wValues );

 if (Board.SideToMove == BLACK) nMax = 29000;
 if (Board.SideToMove == WHITE) nMax = -29000;

 nGood = 0;
 for (i = 0; i < nFound; i++) 
	{
	 if ( (Board.SideToMove == BLACK && wValues[i] <= 0) || (Board.SideToMove == WHITE && wValues[i] >= 0) )
			{
			 nMax = wValues[i];
			 wGoodVal [nGood] = wValues [i];
			 GoodMoves [nGood] = Moves[i];
			 nGood++;
			}
	}

  if (nGood == 0) return NOVAL;

  nMove = rand()%nGood;
  nVal = wGoodVal[ nMove ];

  if (abs(nVal) != 2)
	{
	 nMove = rand()%nGood;
	 nVal = wGoodVal[ nMove ];
	}
 if (abs(nVal) == 0)
	{
	 nMove = rand()%nGood;
	 nVal = wGoodVal[ nMove ];
	}

 if (nMove!=-1)
	{
	AddTranscript (NULL, GoodMoves, nMove, Board);
	Do_Move ( Board, GoodMoves [nMove], u1, u2, WQUEEN);
	}

 return nVal;
}

// ------------------------
// Create a book file from a PGN of games.
// ------------------------
int PGNtoBook ( char buffer[],  int nGame, int nStart, int nEnd, int nTimes, int nAddResults)
        {
        FILE *fp;
		SGameInfo Info;
		char TempBuffer[25];
		int nResult, bNextGame = TRUE;

		Info.tempTime = -1;
		strcpy (Info.sResult, "X");
        
        fp = fopen (buffer, "rt");
        if (fp == NULL) return 0;
 
		char *cliptext = (char* ) malloc ( MAX_LEN + 1 );
		Setup_Board ( GameBoard, 0 );
		g_StartBoard = GameBoard;

		int numGames = 1;
		while ( numGames <= nGame && bNextGame == TRUE )
			{
			bNextGame = ReadGame ( cliptext, fp, Info);
			GameBoard = g_StartBoard;
			GetMovesPGN ( cliptext, FALSE );
			GameBoard = g_StartBoard;

			if (strstr (Info.sResult, "1-0") != NULL) nResult=3;
			else if (strstr (Info.sResult, "0-1") != NULL) nResult=1;
			else nResult=2;

			for (int i = 0; i< (nEnd*2); i++)
				{
				DoMovePGN ( Transcript->Moves [ i ], GameBoard, FALSE, NULL );
				if (i>= ((nStart-1)*2))
					{
					// Draw
					if (nResult==2 && (nAddResults&2)==2 ) pNewBook->AddPosition ( GameBoard, 101, TRUE );
					// Win
					if ( (nAddResults&1)==1 )
						{
						// SideToMove == BLACK means this position is from white's move.
						if (GameBoard.SideToMove == BLACK && nResult==3 ) pNewBook->AddPosition ( GameBoard, 101, TRUE );
						if (GameBoard.SideToMove == WHITE && nResult==1 ) pNewBook->AddPosition ( GameBoard, 101, TRUE );
						}
					// Loss
					if ( (nAddResults&4)==4 )
						{
						if (GameBoard.SideToMove == BLACK && nResult==1 ) pNewBook->AddPosition ( GameBoard, 101, TRUE );
						if (GameBoard.SideToMove == WHITE && nResult==3 ) pNewBook->AddPosition ( GameBoard, 101, TRUE );
						}
					}
				}
			numGames++;
			if ((numGames&7) == 0)
				{
				sprintf (TempBuffer, "%d", numGames );
				DisplayText ( TempBuffer );
				}
			}

		fclose (fp);
		free (cliptext);
		NewGame ( TRUE );

		DisplayText ( "Building opening book...." );
		pNewBook->Save ( "TempGen5.scb", nTimes);
		delete pNewBook;
		pNewBook = new COpeningBook;
		pNewBook->Load ( "TempGen5.scb" );
		DeleteFile ("TempGen5.scb");
		DisplayText ("Finished Adding .PGN");

        return numGames;
        }