#define MAX_MOVES 600 // half moves
#define MAX_LEN 50000

// =======================================
// TRANSCRIPT
// =======================================
struct STranscript
	{
	int nMoves;
	char Moves[MAX_MOVES][8];
	};

struct SGameInfo
{
  char sWhitePlayer[128];
  char sBlackPlayer[128];
  char sEvent[128];
  char sResult[32];
  char sTimeControl[64];
  char sFEN[256];
  int tempTime;
  int nMinutes;
  int nSeconds;

  void Reset ();
};

// functions
void SaveBook();
int LoadOpeningBook(char *sName);
void AddtoBook ( int moves , unsigned char value);
int BookMove (SBoard &Board);
int FindBookMoves (SBoard &Board, int Moves[], int &found);
//
void SaveGame (int LastEval, char buffer[], int bAppend);
int LoadGame ( char buffer[],  int nGame, int bDisplay);
//
void ClearTranscript ( STranscript *pTranscript );
void AddOTranscript (int src, int dst, int index);
void AddTranscript (STranscript *pTranscript, int Moves[], int movenum, SBoard &Board);

void ReplayGame ( SBoard &Board, int i);
int CopyPosition ( char *Text, SBoard Board );

int SetBoardFromText ( char *Text, int nLen );
void GetMoveXYPGN (char textline[], SBoard &Board, int &sX, int &sY, int &dX, int &dY, unsigned char &piece);

void ClipPasteTranscript ( HWND hwnd, int bPos );
//
void TrimList ( void );
void MoveBox ( int iStart );
void UpdateListTranscript ( int bUpdateList );
//
void ClipPasteTranscript ( HWND hwnd);
void ClipCopyTranscript ( HWND hwnd, int bPos);
int DoMovePGN(char textline[], SBoard &Board, int bAddTran, STranscript *pTranscript);
void GetMovesPGN(char text[], int bDoMove);
int CopyTranscript (STranscript *pTranscript, char *clipText, int nMaxLen);

void GetLastMoveTranscript ( char **sMove );
int CurrentBoard ( SBoard &Board );
int NumTranMoves ( );

#define BOOK_EXTRA_SIZE 250000
#define NOVAL -30000

int PGNtoBook ( char buffer[],  int nGame, int nStart, int nEnd, int nTimes, int nAddResults);

// =======================================
// OPENING BOOK
// =======================================
class COpeningBook
{
 // structures needed
 struct SBookEntry
 {
  SBookEntry ()
	{
	pNext = NULL;
	wValue = NOVAL;
	}
  ~SBookEntry ()
	{
	}
  void Save (FILE *pFile, unsigned int wPosKey )
  {
		wPosKey &= 65535;
		fwrite (&ulCheck, 4, 1, pFile);
		fwrite (&wKey   , 2, 1, pFile);
		fwrite (&wValue , 2, 1, pFile);
		fwrite (&wPosKey , 2, 1, pFile);
  }
  unsigned int Load (FILE *pFile )
  {
	unsigned int wPosKey = 0;
	fread (&ulCheck, 4, 1, pFile);
	fread (&wKey   , 2, 1, pFile);
	fread (&wValue , 2, 1, pFile);
	fread (&wPosKey , 2, 1, pFile);
	return wPosKey;
  }

  unsigned long ulCheck;
  SBookEntry* pNext;
  unsigned short wKey;
  short wValue;
 };

 public:
 // ctor&dtor
	COpeningBook ( )
	{
	m_pHash = new SBookEntry [ 131072 ];
	m_pExtra = new SBookEntry [ BOOK_EXTRA_SIZE ];
	m_nListSize = 0;
	m_nPositions = 0;
	}

	~COpeningBook ( )
	{
	delete []m_pHash;
	delete []m_pExtra;
	}

 // Functions
 int FindMoves ( SBoard &Board, int Moves[], short wValues[] );
 int DoMove ( SBoard &Board );
 void RemovePosition ( SBoard &Board, int bQuiet );
 int  GetValue ( SBoard &Board );
 void AddPosition ( SBoard &Board, short wValue, int bQuiet );
 void AddPosition ( unsigned long ulKey,  unsigned long ulCheck, short wValue, int bQuiet );
 int Load (char *sFileName );
 void Save (char *sFileName, int nTimes );

 // Data
 SBookEntry *m_pHash;
 SBookEntry *m_pExtra;
 int m_nListSize;
 int m_nPositions;
};
