//
//
// Slow Chess Winboarding Functions
//
//
#include <stdio.h>
#include <windows.h>
#include <process.h>
#include "data.h"
#include "transcript.h"
#include "gui.h"
#include "search.h"
#include "moves.h"


// -----------------------------------------------------
void wbSendFeatures( )
{
	printf("feature myname=\"%s\" name=1 setboard=1 ping=1\n", g_sSlow);
	fflush(stdout);
	printf("feature done=1\n");
	fflush(stdout);
}

// -----------------------------------------------------
void wbSendPonder(char * szMove)
{
	printf("Hint: %s", szMove);
	fflush(stdout);
}

// -----------------------------------------------------
void  wbSendThinking(int ply, int eval, unsigned long tm, unsigned int nodes, int bPV, int bFailHigh, int bFinishedDepth)
{
	if (bDisplayInfo == FALSE || g_bWinBoard == FALSE) return;

	char sPVbuffer [1060];
	if (bFailHigh == TRUE) 
		{
		int temp = PV[0][0];
		PV[0][0] = 1;
		GetPVString ( sPVbuffer, 0 );
		PV[0][0] = temp;
		strcat (sPVbuffer, "{++}");
		}
		else
		{
		if (bPV == TRUE) GetPVString ( sPVbuffer, 0 );
			else sPVbuffer[0] = NULL;
		}
	if (g_SearchColor == BLACK && bEvalWhite == FALSE) eval = -eval; // flip eval for black

	printf("%d %d %lu %u %s\n", ply, eval, tm, nodes, sPVbuffer);
	fflush(stdout);
	// Maybe display something for bFinishedDepth in thinking?

	// Send analysis in analysis mode
	wbSendThinking2 ( bFinishedDepth );
}

// -----------------------------------------------------
void wbSendResult(char *sResult, char *sWhy)
{
	if (sWhy != NULL)
		printf("%s {%s}\n", sResult, sWhy);
	else
		printf("%s\n", sResult);
	fflush(stdout);
}

// -----------------------------------------------------
void wbTestSendResult ( SBoard &Board )
{
int mate = IsMate (Board, Board.SideToMove );
if (mate == 2) wbSendResult ("1/2-1/2", "Draw by Stalemate");
if (mate == 1)
	{
	if (Board.SideToMove == BLACK) wbSendResult ("1-0", "White Mates");
	if (Board.SideToMove == WHITE) wbSendResult ("0-1", "Black Mates");
	}
if ((Board.nWPawns == 0 && Board.nBPawns == 0) 
	&& (Board.nBP == 0 || Board.nWP == 0) && (Board.nBP <= 1 && Board.nWP <= 1) 
	&& (Board.nWMinors == Board.nWP && Board.nBMinors == Board.nBP ) 
	)
	{
	wbSendResult ("1/2-1/2", "Draw by Insufficent Material to Mate");
	}
if ( (Board.GameTime - Board.LastReversible) >= 100)
	{
	wbSendResult ("1/2-1/2", "Draw by 50 Move Rule");
	}
if ( DrawByRepetition (Board)  > 1 ) 
	{
	wbSendResult ("1/2-1/2", "Draw by Repetition");
	}
}

// -----------------------------------------------------
void wbPonder ( )
{
Thinktime = 1200.0f;
stopthinking = 3;
Sleep(50);
ThinkOfMove ( 1 );
}

// -----------------------------------------------------
//  Enters opponent's move
// -----------------------------------------------------
void wbOppMove ( char *sMove, SBoard &Board )
{
 int sX, sY, dX, dY;
 unsigned char cPiece;
 g_GameResult = NONE;
 GetMoveXYPGN ( sMove, Board, sX, sY, dX, dY, cPiece); 
 PlayerMove (sX, sY, dX, dY, cPiece);
}

// -----------------------------------------------------
//  Starts a new game (sets up board)
// ------------------------------------------------------
void wbNewGame ( )
{
	stopthinking = 3;
	NewGame ( TRUE );
	Thinktime = 2.6f;
	g_GameResult = NONE;
	MaxAhead = 28;
	fPanicTime = 2.0f;
	g_bWinBoard = TRUE;
	PlayerCOLOR = WHITE;
	bAcceptDraw = FALSE;
}

// -----------------------------------------------------
//  Sends the computer's move to Winboard
// -----------------------------------------------------
void wbSendMove( )
{
 char *sTranMove;
 GetLastMoveTranscript ( &sTranMove );

 printf("move %s\n", sTranMove);
 fflush(stdout);
}


// -----------------------------------------------------
// Main Loop
// -----------------------------------------------------
void wbMainLoop ( )
{
int nMode = 0, nSecs = 0, nMoves = 0;
static float fCompTm=60, fOppTm=60;
wbNewGame ( );
char	sBuf[1024];

	while ( 1==1 ) {

		if (fgets(sBuf, sizeof(sBuf), stdin) != sBuf)
			break;

		if ( strstr (sBuf, "accepted"))
			{
			continue;
			}

		if ( strstr (sBuf, "name"))
			{
			sscanf (sBuf, "name %s", sUserName );
			}

		if (strstr (sBuf, "time") )
			{
			sscanf (sBuf, "time %f", &fCompTm);
			if (PlayerCOLOR == BLACK) g_nWhiteTime = Minutes * 6000 - (int)fCompTm;
				else g_nBlackTime = Minutes * 6000 - (int)fCompTm;
			}
		if (strstr (sBuf, "otim") )
			{
			sscanf (sBuf, "otim %f", &fOppTm);
			if (PlayerCOLOR == BLACK) g_nBlackTime = Minutes * 6000 - (int)fOppTm;
				else g_nWhiteTime = Minutes * 6000 - (int)fOppTm;
			}
		// Stop playing
		if ( strstr (sBuf, "force" ) )
			{
			nMode = 0;
			PlayerCOLOR = BOTH;
			stopthinking = 3;
			while (thinking != 0) {Sleep(50);}
			}
		// Opponent Moves
		if (isdigit (sBuf[1]) && isdigit(sBuf[3]) ) 
			{
			if (nMode == 1) stopthinking = 3;

			SetThinkTime ( fCompTm *.01f, nMoves, nSecs );

			wbOppMove ( sBuf, GameBoard );
			if (nMode == 1) wbPonder ();
			} 
		// Just Go
		if ( strstr (sBuf, "go" ) )
			{
			nMode = 0;
			if (GameBoard.SideToMove == BLACK) PlayerCOLOR = WHITE; else PlayerCOLOR = BLACK;
			stopthinking = 3;
			while (thinking != 0) {Sleep(50);}
			SetThinkTime ( fCompTm *.01f, nMoves, nSecs );
			g_GameResult = NONE;
			if ( CheckGameOver ( GameBoard, FALSE, g_GameResult) == FALSE)	ThinkOfMove ( 0 );
			}

		if ( strstr (sBuf, "setboard"))
			{
			if (nMode == 1) stopthinking = 3;
			SetBoardFromText ( strstr (sBuf, "setboard") + 7, strlen (sBuf)- 7 );
			if (nMode == 1) wbPonder ();
			}
		if (strstr (sBuf, "level" ) )
			{
			int minutes=0;
			sscanf  (sBuf, "level %d %d %d", &nMoves, &minutes, &nSecs);
			Minutes = minutes;
			Seconds = nSecs;
			}
		if ( strstr (sBuf, "post" ) )
			{
			bDisplayInfo = TRUE;
			}
		if ( strstr (sBuf, "nopost" ) )
			{
			bDisplayInfo = FALSE;
			}
		if ( strstr ( sBuf, "hard") )
			{
			bPonder = TRUE;
			}
		if ( strstr ( sBuf, "easy") )
			{
			bPonder = FALSE;
			}
		if ( strstr (sBuf, "new" ) )
			{
			wbNewGame ( );
			}
		if ( strstr (sBuf, "quit" ) )
			{
			g_bWinBoard = FALSE;
			exit (0);
			}

		if ( strstr (sBuf, "protover" ) )
			{
			wbSendFeatures();
			}

		if ( strstr (sBuf, "undo"))
			{
			if (nMode == 1) stopthinking = 3;
			ReplayGame (GameBoard, GameBoard.GameTime - 1);
			if (nMode == 1) wbPonder ();
			}

		if ( strstr (sBuf, "remove"))
			{
			if (nMode == 1) stopthinking = 3;
			ReplayGame (GameBoard, GameBoard.GameTime - 2);
			if (nMode == 1) wbPonder ();
			}

		if ( strstr (sBuf, "result"))
			{
			if (strstr (sBuf, "1-0") != NULL) g_GameResult = WHITEWINS;
			else if (strstr (sBuf, "0-1") != NULL) g_GameResult = BLACKWINS;
			else g_GameResult = DRAW; 
	
			if (GameBoard.GameTime > 2) 
				SaveGame (g_GameResult, "WinboardGames.pgn", TRUE);	
			stopthinking = 3;
			}

		if ( strstr (sBuf, "draw"))
			{
			if (GameBoard.GameTime > 80 && GameBoard.nWP <=2 && GameBoard.nBP <=2)
				{
				if ( bAcceptDraw == TRUE)
					{
					printf("offer draw\n");
					fflush(stdout);
					}
				}
			}

		if ( strstr (sBuf, "analyze"))
			{
			PlayerCOLOR = BOTH;
			nMode = 1;
			wbPonder ();
			}

		if ( sBuf[0] == '.' && sBuf [1] == '\n')
			{
			wbSendThinking2 ( FALSE );
			}

		if (strstr (sBuf, "sd ") )
			{
			sscanf (sBuf, "sd %d", &MaxAhead );
			}

		if ( sBuf[0] == '?' && sBuf [1] == '\n')
			{
			stopthinking = 1;
			}

		if ( strstr ( sBuf, "ping") )
			{
			int nPing = 0;

			while (thinking != 0)
				{
				stopthinking = 1;
				Sleep(50);
				}
			sscanf (sBuf, "ping %d", &nPing );
			printf("pong %d\n", nPing);
			fflush(stdout);
			}
	
	}
	g_bWinBoard = FALSE;
	exit (0);
}